#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\AreaCopy.fx"
#line 8
uniform float2 fAC_SourceXY <
ui_label = "Source coordinates";
ui_tooltip = "Top left x and y coordinate of the source area.";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1920;
ui_step = 1.0;
> = float2(600, 100);
#line 17
uniform float2 fAC_DestXY <
ui_label = "Destination coordinates";
ui_tooltip = "Top left x and y coordinate of the destination area.";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1920;
ui_step = 1.0;
> = float2(1200, 600);
#line 26
uniform float2 fAC_Size <
ui_label = "Area dimensions";
ui_tooltip = "Size of the area in x and y dimension.";
ui_type = "drag";
ui_min = 0.0;
ui_max = 1920;
ui_step = 1.0;
> = float2(400, 300);
#line 35
uniform float fAC_DestOpacity <
ui_label = "Destination opacity";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.05;
> = 1.0;
#line 43
uniform float fAC_Zoom <
ui_label = "Destination zoom";
ui_tooltip = "Zoom strength of the destination area.";
ui_type = "slider";
ui_min = 1.0;
ui_max = 20.0;
ui_step = 0.05;
> = 1.0;
#line 52
uniform float fAC_DestAngle <
ui_label = "Destination rotation";
ui_tooltip = "Rotation angle of the destination area.";
ui_type = "slider";
ui_min = 0.0;
ui_max = 360;
ui_step = 15.0;
> = 0;
#line 61
uniform bool bAC_EnableDestOutline <
ui_label = "Enable destination outline";
ui_tooltip = "Draws an outline around the destination area.";
> = true;
#line 66
uniform float fAC_DestOutlineWidth <
ui_label = "Outline width";
ui_tooltip = "Outline width of the destination area in pixels.";
ui_type = "slider";
ui_min = 1.0;
ui_max = 30.0;
ui_step = 1.0;
> = 2.0;
#line 75
uniform float fAC_DestOutlineOpacity <
ui_label = "Outline opacity";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.05;
> = 1.0;
#line 83
uniform float3 fAC_DestOutlineColor <
ui_label = "Outline color";
ui_type = "color";
> = float3(1.0, 1.0, 1.0);
#line 88
uniform bool bAC_EnableSourceColorFill <
ui_label = "Enable source color fill";
ui_tooltip = "Fills the source area with a color specified below.";
> = true;
#line 93
uniform float3 fAC_SourceFillColor <
ui_label = "Fill color";
ui_type = "color";
> = float3(0.0, 0.0, 0.0);
#line 98
uniform float fAC_SourceOpacity <
ui_label = "Fill color opacity";
ui_type = "slider";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.05;
> = 0.5;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 106 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\AreaCopy.fx"
#line 109
float4 PS_AreaCopy(float2 texcoord : TEXCOORD) : SV_Target {
float2 pos = texcoord / ReShade::PixelSize;
float4 color = tex2Dlod(ReShade::BackBuffer, float4(texcoord, 0, 0));
float4 colorBackup = color;
float2 areaCenter = fAC_Size/2.0;
float sine, cosine;
float2 sourceCenterCoord;
#line 117
float2 destPos = (pos.xy - fAC_DestXY - areaCenter) / fAC_Zoom + fAC_SourceXY + areaCenter;
float2 destCoord = destPos * ReShade::PixelSize;
#line 120
float2 sourceTopLeft = fAC_SourceXY;
float2 sourceBottomRight = fAC_SourceXY + fAC_Size;
float2 destTopLeft = fAC_DestXY;
float2 destBottomRight = fAC_DestXY + fAC_Size;
#line 125
if (fAC_DestAngle != 0) {
sine = sin(radians(-fAC_DestAngle));
cosine = cos(radians(-fAC_DestAngle));
sourceCenterCoord = (fAC_SourceXY + areaCenter) * ReShade::PixelSize;
#line 130
destCoord -= sourceCenterCoord;
destCoord.x *= ReShade::AspectRatio;
destCoord = float2(cosine * destCoord.x - sine * destCoord.y, cosine * destCoord.y + sine * destCoord.x);
destCoord.x *= 1.0 / ReShade::AspectRatio;
destCoord += sourceCenterCoord;
}
#line 137
float4 colorDest= tex2Dlod(ReShade::BackBuffer, float4(destCoord, 0, 0));
#line 139
if (bAC_EnableSourceColorFill) {
if (pos.x >= sourceTopLeft.x && pos.y >= sourceTopLeft.y && pos.x <= sourceBottomRight.x && pos.y <= sourceBottomRight.y) {
color.xyz = lerp(color.xyz, fAC_SourceFillColor, fAC_SourceOpacity);
}
}
#line 145
if (bAC_EnableDestOutline) {
if (pos.x >= (destTopLeft.x - fAC_DestOutlineWidth) && pos.y >= (destTopLeft.y - fAC_DestOutlineWidth) && pos.x <= (destBottomRight.x + fAC_DestOutlineWidth) && pos.y <= (destBottomRight.y + fAC_DestOutlineWidth)) {
color.xyz = lerp(color.xyz, fAC_DestOutlineColor, fAC_DestOutlineOpacity);
}
}
#line 151
if (pos.x >= destTopLeft.x && pos.y >= destTopLeft.y && pos.x <= destBottomRight.x && pos.y <= destBottomRight.y) {
color.xyz = lerp(colorBackup.xyz, colorDest.xyz, fAC_DestOpacity);
}
#line 155
return color;
}
#line 159
technique AreaCopy {
pass {
VertexShader = PostProcessVS;
PixelShader = PS_AreaCopy;
}
}

