#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\CanvasFog.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Reshade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 17 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\CanvasFog.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 18 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\CanvasFog.fx"
#line 24
uniform float4 ColorA <
ui_label = "Colour (A)";
ui_type = "color";
ui_category = "Gradient controls";
> = float4(1.0, 0.0, 0.0, 1.0);
#line 30
uniform float4 ColorB <
ui_label = "Colour (B)";
ui_type = "color";
ui_category = "Gradient controls";
> = float4(0.0, 0.0, 1.0, 0.0);
#line 36
uniform bool Flip <
ui_label = "Color flip";
ui_category = "Gradient controls";
> = false;
#line 41
uniform bool ColorpA<
ui_label = "Color A picker";
ui_category = "Gradient controls";
ui_tooltip = "Select a color from the screen to be used instead of ColorA. Left-click to sample. Take in mind that it still uses the alpha channel from the color A.\nIts recommended to select the colors after setting everything up since futher clicks will change the desire color.";
> = false;
#line 47
uniform bool ColorpB<
ui_label = "Color B picker";
ui_category = "Gradient controls";
ui_tooltip = "Select a color from the screen to be used instead of ColorB. Left-click to sample. Take in mind that it still uses the alpha channel from the color B.\nIts recommended to select the colors after setting everything up since futher clicks will change the desire color.";
> = false;
#line 53
uniform int GradientType <
ui_type = "combo";
ui_label = "Gradient Type";
ui_category = "Gradient controls";
ui_items = "Linear\0Radial\0Strip\0Diamond\0";
> = 0;
#line 60
uniform int BlendM <
ui_type = "combo";
ui_label = "Blending Mode";
ui_tooltip = "Select the blending mode used with the gradient on the screen.";
ui_items = "Normal\0Multiply\0Screen\0Overlay\0Darken\0Lighten\0Color Dodge\0Color Burn\0Hard Light\0Soft Light\0Difference\0Exclusion\0Hue\0Saturation\0Color\0Luminosity\0Linear burn\0Linear dodge\0Vivid light\0Linearlight\0Pin light\0Hardmix\0Reflect\0Glow\0";
ui_category = "Gradient controls";
> = 0;
#line 68
uniform float Scale <
ui_label = "Gradient sharpness";
ui_type = "slider";
ui_min = -10.0; ui_max = 10.0; ui_step = 0.0001;
ui_category = "Gradient controls";
> = 1.0;
#line 75
uniform float Axis <
ui_label = "Angle";
ui_type = "slider";
ui_step = 0.1;
ui_min = -180.0; ui_max = 180.0;
ui_category = "Linear gradient control";
#line 82
> = 0.0;
#line 84
uniform float Offset <
ui_type = "slider";
ui_label = "Position";
ui_step = 0.002;
ui_min = -0.5; ui_max = 0.5;
ui_category = "Linear gradient control";
> = 0.0;
#line 92
uniform float Size <
ui_label = "Size";
ui_type = "slider";
ui_step = 0.002;
ui_min = 0.0; ui_max = 1.0;
ui_category = "Radial gradient control";
ui_category_closed = true;
> = 0.0;
#line 101
uniform float2 Originc <
ui_category = "Radial gradient control";
ui_label = "Position";
ui_type = "slider";
ui_step = 0.001;
ui_min = -1.5; ui_max = 2;
> = float2(0.5, 0.5);
#line 109
uniform float2 Modifierc <
ui_category = "Radial gradient control";
ui_label = "Modifier";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0.000; ui_max = 10.000;
> = float2(1.0, 1.0);
#line 117
uniform float AnguloR <
ui_category = "Radial gradient control";
ui_label = "Angle";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0; ui_max = 360;
> = 0.0;
#line 125
uniform float SizeS <
ui_category = "Strip gradient control";
ui_label = "Size";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0; ui_max = 100;
ui_category_closed = true;
> = 0.0;
#line 134
uniform float2 PositionS <
ui_category = "Strip gradient control";
ui_label = "Position";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0; ui_max = 1;
> = float2(0.5, 0.5);
#line 142
uniform float AnguloS <
ui_category = "Strip gradient control";
ui_label = "Angle";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0; ui_max = 360;
> = 0.0;
#line 152
uniform float Sized <
ui_label = "Size";
ui_type = "slider";
ui_step = 0.002;
ui_min = 0.0; ui_max = 7.0;
ui_category = "Diamond gradient control";
ui_category_closed = true;
> = 0.0;
#line 161
uniform float2 Origind <
ui_category = "Diamond gradient control";
ui_label = "Position";
ui_type = "slider";
ui_step = 0.001;
ui_min = -1.5; ui_max = 2;
> = float2(0.5, 0.5);
#line 169
uniform float2 Modifierd <
ui_category = "Diamond gradient control";
ui_label = "Modifier";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0.000; ui_max = 10.000;
> = float2(1.0, 1.0);
#line 177
uniform float Angulod <
ui_category = "Diamond gradient control";
ui_label = "Angle";
ui_type = "slider";
ui_step = 0.001;
ui_min = 0; ui_max = 360;
> = 0.0;
#line 187
uniform int FogType <
ui_type = "combo";
ui_label = "Fog type";
ui_category = "Fog controls";
ui_items = "Adaptive Fog\0Emphasize Fog\0";
ui_category_closed = true;
> = false;
#line 195
uniform bool FlipFog <
ui_label = "Fog flip";
ui_category = "Fog controls";
> = false;
#line 200
uniform float MaxFogFactor <
ui_type = "slider";
ui_min = 0.000; ui_max=1.000;
ui_tooltip = "The maximum fog factor. 1.0 makes distant objects completely fogged out, a lower factor will shimmer them through the fog.";
ui_step = 0.001;
ui_category = "AdaptiveFog controls";
> = 1.0;
#line 208
uniform float FogCurve <
ui_type = "slider";
ui_min = 0.00; ui_max=175.00;
ui_step = 0.01;
ui_tooltip = "The curve how quickly distant objects get fogged. A low value will make the fog appear just slightly. A high value will make the fog kick in rather quickly. The max value in the rage makes it very hard in general to view any objects outside fog.";
ui_category = "AdaptiveFog controls";
> = 170;
#line 216
uniform float FogStart <
ui_type = "slider";
ui_min = 0.000; ui_max=1.000;
ui_step = 0.001;
ui_category = "AdaptiveFog controls";
ui_tooltip = "Start of the fog. 0.0 is at the camera, 1.0 is at the horizon, 0.5 is halfway towards the horizon. Before this point no fog will appear.";
> = 0.2;
#line 224
uniform float BloomThreshold <
ui_type = "slider";
ui_min = 0.00; ui_max=50.00;
ui_step = 0.1;
ui_tooltip = "Threshold for what is a bright light (that causes bloom) and what isn't.";
ui_category = "AdaptiveFog-Bloom controls";
ui_category_closed = true;
> = 10.25;
#line 233
uniform float BloomPower <
ui_type = "slider";
ui_min = 0.000; ui_max=100.000;
ui_step = 0.1;
ui_tooltip = "Strength of the bloom";
ui_category = "AdaptiveFog-Bloom controls";
> = 0.0; 
#line 241
uniform float BloomWidth <
ui_type = "slider";
ui_min = 0.0000; ui_max=1.0000;
ui_tooltip = "Width of the bloom";
ui_category = "AdaptiveFog-Bloom controls";
> = 0.2;
#line 248
uniform float FocusDepth <
ui_type = "slider";
ui_min = 0.000; ui_max = 1.000;
ui_step = 0.001;
ui_tooltip = "Manual focus depth of the point which has the focus. Range from 0.0, which means camera is the focus plane, till 1.0 which means the horizon is focus plane.";
ui_category = "EmphasizeFog controls";
ui_category_closed = true;
> = 0.026;
#line 257
uniform float FocusRangeDepth <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.000;
ui_step = 0.001;
ui_tooltip = "The depth of the range around the manual focus depth which should be emphasized. Outside this range, de-emphasizing takes place";
ui_category = "EmphasizeFog controls";
> = 0.001;
#line 265
uniform float FocusEdgeDepth <
ui_type = "slider";
ui_min = 0.000; ui_max = 1.000;
ui_tooltip = "The depth of the edge of the focus range. Range from 0.00, which means no depth, so at the edge of the focus range, the effect kicks in at full force,\ntill 1.00, which means the effect is smoothly applied over the range focusRangeEdge-horizon.";
ui_category = "EmphasizeFog controls";
ui_step = 0.001;
> = 0.050;
#line 275
uniform float FogCurveE <
ui_label = "Sharpness";
ui_type = "slider";
ui_min = 0.00; ui_max=1;
ui_step = 0.01;
ui_category = "EmphasizeFog controls";
> = 0;
#line 284
uniform bool Spherical <
ui_tooltip = "Enables Emphasize in a sphere around the focus-point instead of a 2D plane";
ui_category = "EmphasizeFog controls";
> = false;
#line 289
uniform int Sphere_FieldOfView <
ui_type = "slider";
ui_min = 1; ui_max = 180;
ui_tooltip = "Specifies the estimated Field of View you are currently playing with. Range from 1, which means 1 Degree, till 180 which means 180 Degree (half the scene).\nNormal games tend to use values between 60 and 90.";
ui_category = "EmphasizeFog controls";
> = 75;
#line 296
uniform float Sphere_FocusHorizontal <
ui_type = "slider";
ui_min = 0; ui_max = 1;
ui_tooltip = "Specifies the location of the focuspoint on the horizontal axis. Range from 0, which means left screen border, till 1 which means right screen border.";
ui_category = "EmphasizeFog controls";
> = 0.5;
#line 303
uniform float Sphere_FocusVertical <
ui_type = "slider";
ui_min = 0; ui_max = 1;
ui_tooltip = "Specifies the location of the focuspoint on the vertical axis. Range from 0, which means upper screen border, till 1 which means bottom screen border.";
ui_category = "EmphasizeFog controls";
> = 0.5;
#line 310
uniform float3 BlendColor <
ui_type = "color";
ui_tooltip = "Specifies the blend color to blend with the rest of the scene. in (Red, Green, Blue). Use dark colors to darken further away objects";
ui_category = "EmphasizeFog controls";
> = float3(0.0, 0.0, 0.0);
#line 316
uniform float BlendFactor <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_tooltip = "Specifies the factor BlendColor is blended. Range from 0.0, which means no color blending, till 1.0 which means full blend of the BlendColor";
ui_category = "EmphasizeFog controls";
> = 0.0;
#line 323
uniform float EffectFactor <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_tooltip = "Specifies the factor the blending is applied. Range from 0.0, which means the effect is off (normal image), till 1.0 which means the blended parts are\nfull blended";
ui_category = "EmphasizeFog controls";
> = 0.9;
#line 332
uniform float2 FogRotationAngle  <
ui_label = "Angle of fog rotation";
ui_type = "slider";
ui_min = -1; ui_max = 1; ui_step = 0.01;
ui_category = "Fog Rotation (experimental)";
> = float2(0, 0);
#line 339
uniform float2 FogRotationCenter  <
ui_label = "Center of rotation";
ui_type = "slider";
ui_min = 0; ui_max = 1;
ui_category = "Fog Rotation (experimental)";
> = float2(0.5, 0.5);
#line 346
uniform bool Texture <
ui_label = "Texture";
ui_category = "Fog Rotation (experimental)";
> = false;
#line 359
float3 Screen(float3 LayerA, float3 LayerB)
{ return 1.0 - (1.0 - LayerA) * (1.0 - LayerB); }
#line 363
float3 Multiply(float3 LayerA, float3 LayerB)
{ return LayerA * LayerB; }
#line 367
float3 Darken(float3 LayerA, float3 LayerB)
{ return min(LayerA,LayerB); }
#line 371
float3 Lighten(float3 LayerA, float3 LayerB)
{ return max(LayerA,LayerB); }
#line 375
float3 ColorDodge(float3 LayerA, float3 LayerB)
{ return LayerB>=1.0f ? LayerB:saturate(LayerA/(1.0f-LayerB));}
#line 379
float3 ColorBurn(float3 LayerA, float3 LayerB)
{ return LayerB<=0.0f ? LayerB:saturate(1.0f-((1.0f-LayerA)/LayerB)); }
#line 383
float3 HardLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(Multiply(LayerA,2*LayerB),0,1) : clamp(Multiply(LayerA,2*LayerB-1),0,1);}
#line 386
float3 Aux(float3 x)
{ return (x.r<=0.25 && x.g<=0.25 && x.b<=0.25) ? ((16.0*x-12.0)*x+4)*x : sqrt(x);}
#line 390
float3 SoftLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(LayerA-(1.0-2*LayerB)*LayerA*(1-LayerA),0,1) : clamp(LayerA+(2*LayerB-1.0)*(Aux(LayerA)-LayerA),0,1);}
#line 395
float3 Difference(float3 LayerA, float3 LayerB)
{ return LayerA-LayerB; }
#line 399
float3 Exclusion(float3 LayerA, float3 LayerB)
{ return LayerA+LayerB-2*LayerA*LayerB; }
#line 403
float3 Overlay(float3 c, float3 b)
{ return c<0.5f ? 2.0f*c*b:(1.0f-2.0f*(1.0f-c)*(1.0f-b));}
#line 407
float Lum(float3 c){
return (0.3*c.r+0.59*c.g+0.11*c.b);}
#line 410
float min3 (float a, float b, float c){
return min(a,(min(b,c)));
}
#line 414
float max3 (float a, float b, float c){
return max(a,(max(b,c)));
}
#line 418
float Sat(float3 c){
return max3(c.r,c.g,c.b)-min3(c.r,c.g,c.b);}
#line 421
float3 ClipColor(float3 c){
float l=Lum(c);
float n=min3(c.r,c.g,c.b);
float x=max3(c.r,c.g,c.b);
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (n<0){
cr=l+(((cr-l)*l)/(l-n));
cg=l+(((cg-l)*l)/(l-n));
cb=l+(((cb-l)*l)/(l-n));
}
if (x>1){
cr=l+(((cr-l)*(1-l))/(x-l));
cg=l+(((cg-l)*(1-l))/(x-l));
cb=l+(((cb-l)*(1-l))/(x-l));
}
return float3(cr,cg,cb);
}
#line 441
float3 SetLum (float3 c, float l){
float d= l-Lum(c);
return float3(c.r+d,c.g+d,c.b+d);
}
#line 446
float3 SetSat(float3 c, float s){
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (cr==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cr>cb){
cg=(((cg-cb)*s)/(cr-cb));
cr=s;
}
else{
cg=0;
cr=0;
}
cb=0;
}
else{
if (cr==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cr>cg){
cb=(((cb-cg)*s)/(cr-cg));
cr=s;
}
else{
cb=0;
cr=0;
}
cg=0;
}
else{
if (cg==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cg>cb){
cr=(((cr-cb)*s)/(cg-cb));
cg=s;
}
else{
cr=0;
cg=0;
}
cb=0;
}
else{
if (cg==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cg>cr){
cb=(((cb-cr)*s)/(cg-cr));
cg=s;
}
else{
cb=0;
cg=0;
}
cr=0;
}
else{
if (cb==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cb>cg){
cr=(((cr-cg)*s)/(cb-cg));
cb=s;
}
else{
cr=0;
cb=0;
}
cg=0;
}
else{
if (cb==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cb>cr){
cg=(((cg-cr)*s)/(cb-cr));
cb=s;
}
else{
cg=0;
cb=0;
}
cr=0;
}
}
}
}
}
}
return float3(cr,cg,cb);
}
#line 529
float3 Hue(float3 b, float3 s){
return SetLum(SetSat(s,Sat(b)),Lum(b));
}
#line 533
float3 Saturation(float3 b, float3 s){
return SetLum(SetSat(b,Sat(s)),Lum(b));
}
#line 537
float3 ColorM(float3 b, float3 s){
return SetLum(s,Lum(b));
}
#line 541
float3 Luminosity(float3 b, float3 s){
return SetLum(b,Lum(s));
}
#line 549
float3 Linearburn(float3 c, float3 b) 	{ return max(c+b-1.0f, 0.0f);}
#line 551
float3 Lineardodge(float3 c, float3 b) 	{ return min(c+b, 1.0f);}
#line 553
float3 Vividlight(float3 c, float3 b) 	{ return b<0.5f ? ColorBurn(c, (2.0f*b)):ColorDodge(c, (2.0f*(b-0.5f)));}
#line 555
float3 Linearlight(float3 c, float3 b) 	{ return b<0.5f ? Linearburn(c, (2.0f*b)):Lineardodge(c, (2.0f*(b-0.5f)));}
#line 557
float3 Pinlight(float3 c, float3 b) 	{ return b<0.5f ? Darken(c, (2.0f*b)):Lighten(c, (2.0f*(b-0.5f)));}
#line 559
float3 Hardmix(float3 c, float3 b)      { return Vividlight(c,b)<0.5f ? float3(0.0,0.0,0.0):float3(1.0,1.0,1.0);}
#line 561
float3 Reflect(float3 c, float3 b)      { return b>=0.999999f ? b:saturate(c*c/(1.0f-b));}
#line 563
float3 Glow(float3 c, float3 b)         { return Reflect(b, c);}
#line 567
float DistToLine(float2 pt1, float2 pt2, float2 testPt)
{
float2 lineDir = pt2 - pt1;
float2 perpDir = float2(lineDir.y, -lineDir.x);
float2 dirToPt1 = pt1 - testPt;
return abs(dot(normalize(perpDir), dirToPt1));
}
#line 576
float2 rotate(float2 v,float2 o, float a){
float2 v2= v-o;
v2=float2((cos(a) * v2.x-sin(a)*v2.y),sin(a)*v2.x +cos(a)*v2.y);
v2=v2+o;
return v2;
}
#line 586
texture   Otis_BloomTarget 	{ Width = 1920; Height = 1080; Format = RGBA8;};
texture ATexture1		{ Width = 1; Height = 1;};		
texture ATexture2		{ Width = 1; Height = 1;};		
texture BTexture1		{ Width = 1; Height = 1;};		
texture BTexture2		{ Width = 1; Height = 1;};		
#line 595
sampler2D Otis_BloomSampler { Texture = Otis_BloomTarget; };
sampler ColorAsavernew		{ Texture = ATexture1; };
sampler ColorAsaverold		{ Texture = ATexture2; };
sampler ColorBsavernew		{ Texture = BTexture1; };
sampler ColorBsaverold		{ Texture = BTexture2; };
#line 602
void PS_Otis_AFG_PerformBloom(float4 position : SV_Position, float2 texcoord : TEXCOORD0, out float4 fragment: SV_Target0)
{
float4 color = tex2D(ReShade::BackBuffer, texcoord);
float3 BlurColor2 = 0;
float3 Blurtemp = 0;
const float MaxDistance = 8*BloomWidth;
float CurDistance = 0;
const float Samplecount = 25.0;
const float2 blurtempvalue = texcoord * ReShade::PixelSize * BloomWidth;
float2 BloomSample = float2(2.5,-2.5);
float2 BloomSampleValue;
#line 614
for(BloomSample.x = (2.5); BloomSample.x > -2.0; BloomSample.x = BloomSample.x - 1.0)
{
BloomSampleValue.x = BloomSample.x * blurtempvalue.x;
float2 distancetemp = BloomSample.x * BloomSample.x * BloomWidth;
#line 619
for(BloomSample.y = (- 2.5); BloomSample.y < 2.0; BloomSample.y = BloomSample.y + 1.0)
{
distancetemp.y = BloomSample.y * BloomSample.y;
CurDistance = (distancetemp.y * BloomWidth) + distancetemp.x;
BloomSampleValue.y = BloomSample.y * blurtempvalue.y;
Blurtemp.rgb = tex2D(ReShade::BackBuffer, float2(texcoord + BloomSampleValue)).rgb;
BlurColor2.rgb += lerp(Blurtemp.rgb,color.rgb, sqrt(CurDistance / MaxDistance));
}
}
BlurColor2.rgb = (BlurColor2.rgb / (Samplecount - (BloomPower - BloomThreshold*5)));
const float Bloomamount = (dot(color.rgb,float3(0.299f, 0.587f, 0.114f)));
const float3 BlurColor = BlurColor2.rgb * (BloomPower + 4.0);
color.rgb = lerp(color.rgb,BlurColor.rgb, Bloomamount);
fragment = saturate(color);
}
#line 636
uniform float2 MouseCoords < source = "mousepoint"; >;
uniform bool LeftMouseDown < source = "mousebutton"; keycode = 0; toggle = false; >;
#line 640
float CalculateDepthDiffCoC(float2 texcoord : TEXCOORD)
{
const float scenedepth = ReShade::GetLinearizedDepth(texcoord);
const float scenefocus =  FocusDepth;
const float desaturateFullRange = FocusRangeDepth*FocusEdgeDepth;
float depthdiff;
#line 647
if(Spherical == true)
{
texcoord.x = (texcoord.x-Sphere_FocusHorizontal)*ReShade::ScreenSize.x;
texcoord.y = (texcoord.y-Sphere_FocusVertical)*ReShade::ScreenSize.y;
const float degreePerPixel = Sphere_FieldOfView / ReShade::ScreenSize.x;
const float fovDifference = sqrt((texcoord.x*texcoord.x)+(texcoord.y*texcoord.y))*degreePerPixel;
float fovt=cos(fovDifference*(2* 3.1415927/360));
depthdiff = sqrt((scenedepth*scenedepth)+(scenefocus*scenefocus)-(2*scenedepth*scenefocus*fovt-2*scenedepth*scenefocus*(1-FogCurveE)));
#line 656
}
else
{
depthdiff = abs(scenedepth-scenefocus);
}
#line 662
if (depthdiff > desaturateFullRange)
return saturate(1.0);
else
return saturate(smoothstep(0, desaturateFullRange, (depthdiff*(1-FogCurveE))));
}
#line 669
float3 Blender(float3 CA, float3 CB, float2 texcoord, float gradient, float fogFactor){
float3 fragment = tex2D(ReShade::BackBuffer, texcoord).rgb;
float3 prefragment=lerp(tex2D(ReShade::BackBuffer, texcoord).rgb, lerp(tex2D(Otis_BloomSampler, texcoord).rgb, lerp(CA.rgb, CB.rgb, Flip ? 1 - gradient : gradient), fogFactor), fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));
switch (BlendM){
case 0:{fragment=prefragment;break;}
case 1:{fragment=lerp(fragment.rgb,Multiply(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 2:{fragment=lerp(fragment.rgb,Screen(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 3:{fragment=lerp(fragment.rgb,Overlay(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 4:{fragment=lerp(fragment.rgb,Darken(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 5:{fragment=lerp(fragment.rgb,Lighten(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 6:{fragment=lerp(fragment.rgb,ColorDodge(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 7:{fragment=lerp(fragment.rgb,ColorBurn(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 8:{fragment=lerp(fragment.rgb,HardLight(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 9:{fragment=lerp(fragment.rgb,SoftLight(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 10:{fragment=lerp(fragment.rgb,Difference(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 11:{fragment=lerp(fragment.rgb,Exclusion(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 12:{fragment=lerp(fragment.rgb,Hue(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 13:{fragment=lerp(fragment.rgb,Saturation(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 14:{fragment=lerp(fragment.rgb,ColorM(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 15:{fragment=lerp(fragment.rgb,Luminosity(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 16:{fragment=lerp(fragment.rgb,Linearburn(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 17:{fragment=lerp(fragment.rgb,Lineardodge(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 18:{fragment=lerp(fragment.rgb,Vividlight(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 19:{fragment=lerp(fragment.rgb,Linearlight(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 20:{fragment=lerp(fragment.rgb,Pinlight(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 21:{fragment=lerp(fragment.rgb,Hardmix(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 22:{fragment=lerp(fragment.rgb,Reflect(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
case 23:{fragment=lerp(fragment.rgb,Glow(fragment.rgb,prefragment),fogFactor*lerp(ColorA.a, ColorB.a, Flip ? 1 - gradient : gradient));break;}
}
return fragment;
}
#line 701
uniform float Timer < source = "timer"; >;
#line 712
float3 mod289(float3 x) {
return x - floor(x * (1.0 / 289.0)) * 289.0;
}
#line 716
float2 mod289(float2 x) {
return x - floor(x * (1.0 / 289.0)) * 289.0;
}
#line 721
float3 mod7(float3 x) {
return x - floor(x * (1.0 / 7.0)) * 7.0;
}
#line 726
float3 permute(float3 x) {
return mod289((34.0 * x + 1.0) * x);
}
#line 776
texture texFogNoise				< source = "fognoise.jpg"; > { Width = 512; Height = 512; Format = RGBA8; };
sampler SamplerFogNoise				{ Texture = texFogNoise; MipFilter = POINT; MinFilter = POINT; MagFilter = POINT; AddressU = WRAP; AddressV = WRAP; AddressW = WRAP;};
#line 780
void PS_Otis_Original_BlendFogWithNormalBuffer(float4 vpos: SV_Position, float2 texcoord: TEXCOORD, out float4 fragment: SV_Target0)
{
#line 783
fragment.rgba = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 785
const float depth = ReShade::GetLinearizedDepth(texcoord).r;
float fogFactor;
switch(FogType){
#line 791
case 0:{
#line 846
float2 uv = float2(1920, 1080) / float2( 512.0f, 512.0f ); 
uv.xy = uv.xy * texcoord.xy;
#line 849
float noise = tex2D(SamplerFogNoise, uv).x; 
#line 854
fogFactor= clamp((-(texcoord.x-FogRotationCenter.x)*FogRotationAngle.x-(texcoord.y-FogRotationCenter.y)*FogRotationAngle.y+depth - FogStart) * FogCurve, 0.0, saturate(MaxFogFactor+depth));
#line 866
if (fogFactor!=0 && Texture) fogFactor= saturate(fogFactor-(1-fogFactor)*noise);
#line 870
break;
#line 873
}
case 1:{
fogFactor= 1-CalculateDepthDiffCoC(texcoord.xy);break;
}
}
#line 879
if (FlipFog) {fogFactor = 1-clamp(saturate(depth - FogStart) * FogCurve, 0.0, 1-MaxFogFactor);}
#line 882
float3 ColorAreal= ColorpA ? tex2D(ColorAsavernew, float2(0,0)).rgb : ColorA.rgb;
float3 ColorBreal= ColorpB ? tex2D(ColorBsavernew, float2(0,0)).rgb : ColorB.rgb;
#line 885
switch (GradientType){
case 0: {
float2 origin = float2(0.5, 0.5);
float2 uvtest= float2(texcoord.x-origin.x,texcoord.y-origin.y);
float angle=radians(Axis);
uvtest = float2(cos(angle) * uvtest.x-sin(angle)*uvtest.y, sin(angle)*uvtest.y +cos(angle)*uvtest.x)+Offset;
float gradient= (Scale<0) ? saturate(uvtest.x*(-pow(2,abs(Scale)))+Offset) : saturate(uvtest.x*pow(2,abs(Scale))+Offset);
fragment= Blender(ColorAreal, ColorBreal, texcoord, gradient, fogFactor);
break;
}
case 1: {
float distfromcenter=distance(float2(Originc.x*Modifierc.x, Originc.y*Modifierc.y), float2(((texcoord.x*1920-(1920-1080)/2)/1080)*Modifierc.x,texcoord.y*Modifierc.y));
float angle=radians(AnguloR);
float2 uvtemp=float2(((texcoord.x*1920-(1920-1080)/2)/1080),texcoord.y);
float dist = distance(Originc*Modifierc,rotate(uvtemp,Originc,angle)*Modifierc);
float gradient= (Scale<0) ? saturate((dist-Size)*(-exp(abs(Scale)))) : saturate((dist-Size)*(exp(abs(Scale))));
fragment= Blender(ColorAreal, ColorBreal, texcoord, gradient, fogFactor);
break;
}
case 2: {
float2 ubs = texcoord;
ubs.y = 1.0 - ubs.y;
float gradient = saturate((DistToLine(PositionS, float2(PositionS.x-sin(radians(AnguloS)),PositionS.y-cos(radians(AnguloS))), ubs) * 2.0)*(pow(2,Scale-SizeS+2))-SizeS);
fragment= Blender(ColorAreal, ColorBreal, texcoord, gradient, fogFactor);
break;
}
case 3:{
float angle=radians(Angulod);
float2 mod=rotate(Modifierd,float2(1,1),radians(45));
#line 921
float2 uv=rotate(float2(((texcoord.x*1920-(1920-1080)/2)/1080)*Modifierd.x,texcoord.y*Modifierd.y),Origind*Modifierd,radians(45));
uv=rotate(uv,Origind*Modifierd,radians(Angulod));
float gradient = 1 - pow(max(abs((uv.x - Origind.x*Modifierd.x)/Sized), abs((uv.y - Origind.y*Modifierd.y)/Sized)),exp(Scale+3));
fragment= Blender(ColorAreal, ColorBreal, texcoord, saturate(gradient), fogFactor);
break;
}
}
}
#line 930
void ColorAgrab(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 933
Image= LeftMouseDown ? tex2D(ReShade::BackBuffer, MouseCoords*ReShade::PixelSize).rgb : tex2D(ColorAsaverold, float2(0,0)).rgb;
}
#line 936
void ColorAcopy(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 939
Image = tex2D(ColorAsavernew, float2(0,0)).rgb;
}
#line 942
void ColorBgrab(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 945
Image = LeftMouseDown ? tex2D(ReShade::BackBuffer, MouseCoords*ReShade::PixelSize).rgb : tex2D(ColorBsaverold, float2(0,0)).rgb;
}
#line 948
void ColorBcopy(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 951
Image = tex2D(ColorBsavernew, float2(0,0)).rgb;
}
#line 958
technique CanvasFog
{
pass ColorpickercopyA{
VertexShader = PostProcessVS;
PixelShader = ColorAcopy;
RenderTarget = ATexture2;
}
pass ColorpickerA{
VertexShader = PostProcessVS;
PixelShader = ColorAgrab;
RenderTarget = ATexture1;
}
pass ColorpickercopyB{
VertexShader = PostProcessVS;
PixelShader = ColorBcopy;
RenderTarget = BTexture2;
}
pass ColorpickerB{
VertexShader = PostProcessVS;
PixelShader = ColorBgrab;
RenderTarget = BTexture1;
}
pass Otis_AFG_PassBloom0
{
VertexShader = PostProcessVS;
PixelShader = PS_Otis_AFG_PerformBloom;
RenderTarget = Otis_BloomTarget;
}
#line 987
pass Otis_AFG_PassBlend
{
VertexShader = PostProcessVS;
PixelShader = PS_Otis_Original_BlendFogWithNormalBuffer;
}
}

