#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Clarity.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 7 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Clarity.fx"
#line 9
uniform int ClarityRadius
<        ui_type = "slider"; 
ui_min = 0; ui_max = 4;
ui_tooltip = "[0|1|2|3|4] Higher values will increase the radius of the effect.";
ui_step = 1.00;
> = 3;
#line 16
uniform float ClarityOffset
<      ui_type = "slider"; 
ui_min = 1.00; ui_max = 5.00;
ui_tooltip = "Additional adjustment for the blur radius. Increasing the value will increase the radius.";
ui_step = 1.00;
> = 2.00;
#line 23
uniform int ClarityBlendMode
<
ui_type = "combo";
ui_items = "\Soft Light\0Overlay\0Hard Light\0Multiply\0Vivid Light\0Linear Light\0Addition";
ui_tooltip = "Blend modes determine how the clarity mask is applied to the original image";
> = 2;
#line 30
uniform int ClarityBlendIfDark
<        ui_type = "slider"; 
ui_min = 0; ui_max = 255;
ui_tooltip = "Any pixels below this value will be excluded from the effect. Set to 50 to target mid-tones.";
ui_step = 5;
> = 50;
#line 37
uniform int ClarityBlendIfLight
<        ui_type = "slider"; 
ui_min = 0; ui_max = 255;
ui_tooltip = "Any pixels above this value will be excluded from the effect. Set to 205 to target mid-tones.";
ui_step = 5;
> = 205;
#line 44
uniform bool ClarityViewBlendIfMask
<
ui_tooltip = "The mask used for BlendIf settings. The effect will not be applied to areas covered in black";
> = false;
#line 49
uniform float ClarityStrength
<      ui_type = "slider"; 
ui_min = 0.00; ui_max = 1.00;
ui_tooltip = "Adjusts the strength of the effect";
> = 0.400;
#line 55
uniform float ClarityDarkIntensity
<      ui_type = "slider"; 
ui_min = 0.00; ui_max = 1.00;
ui_tooltip = "Adjusts the strength of dark halos.";
> = 0.400;
#line 61
uniform float ClarityLightIntensity
<      ui_type = "slider"; 
ui_min = 0.00; ui_max = 1.00;
ui_tooltip = "Adjusts the strength of light halos.";
> = 0.000;
#line 67
uniform bool ClarityViewMask
<
ui_tooltip = "The mask is what creates the effect. View it when making adjustments to get a better idea of how your changes will affect the image.";
> = false;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 72 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Clarity.fx"
#line 74
texture ClarityTex < pooled = true; > { Width = 1920 * 0.5; Height = 1080 * 0.5; Format = R8; };
texture ClarityTex2 { Width = 1920 * 0.5; Height = 1080 * 0.5; Format = R8; };
texture ClarityTex3 < pooled = true; > { Width = 1920 * 0.25; Height = 1080 * 0.25; Format = R8; };
#line 78
sampler ClaritySampler { Texture = ClarityTex;};
sampler ClaritySampler2 { Texture = ClarityTex2;};
sampler ClaritySampler3 { Texture = ClarityTex3;};
#line 82
float3 ClarityFinal(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
#line 85
float color = tex2D(ClaritySampler3, texcoord).r;
#line 87
if(ClarityRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 92
color *= weight[0];
#line 94
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(ClaritySampler3, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
color += tex2D(ClaritySampler3, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
}
}
#line 102
if(ClarityRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 107
color *= weight[0];
#line 109
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(ClaritySampler3, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
color += tex2D(ClaritySampler3, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
}
}
#line 117
if(ClarityRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 122
color *= weight[0];
#line 124
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(ClaritySampler3, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
color += tex2D(ClaritySampler3, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
}
}
#line 132
if(ClarityRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 137
color *= weight[0];
#line 139
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(ClaritySampler3, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
color += tex2D(ClaritySampler3, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
}
}
#line 147
if(ClarityRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 152
color *= weight[0];
#line 154
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(ClaritySampler3, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
color += tex2D(ClaritySampler3, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r * weight[i];
}
}
#line 162
float3 orig = tex2D(ReShade::BackBuffer, texcoord).rgb; 
float luma = dot(orig.rgb,float3(0.32786885,0.655737705,0.0163934436));
float3 chroma = orig.rgb/luma;
#line 166
float sharp = 1-color;
sharp = (luma+sharp)*0.5;
#line 169
float sharpMin = lerp(0.0,1.0,smoothstep(0.0,1.0,sharp));
float sharpMax = sharpMin;
sharpMin = lerp(sharp,sharpMin,ClarityDarkIntensity);
sharpMax = lerp(sharp,sharpMax,ClarityLightIntensity);
sharp = lerp(sharpMin,sharpMax,step(0.5,sharp));
#line 175
if(ClarityViewMask)
{
orig.rgb = sharp;
luma = sharp;
chroma = 1.0;
}
else
{
if(ClarityBlendMode == 0)
{
#line 186
sharp = lerp(2*luma*sharp + luma*luma*(1.0-2*sharp), 2*luma*(1.0-sharp)+pow(luma,0.5)*(2*sharp-1.0), step(0.49,sharp));
}
#line 189
if(ClarityBlendMode == 1)
{
#line 192
sharp = lerp(2*luma*sharp, 1.0 - 2*(1.0-luma)*(1.0-sharp), step(0.50,luma));
}
#line 195
if(ClarityBlendMode == 2)
{
#line 198
sharp = lerp(2*luma*sharp, 1.0 - 2*(1.0-luma)*(1.0-sharp), step(0.50,sharp));
}
#line 201
if(ClarityBlendMode == 3)
{
#line 204
sharp = saturate(2 * luma * sharp);
}
#line 207
if(ClarityBlendMode == 4)
{
#line 210
sharp = lerp(2*luma*sharp, luma/(2*(1-sharp)), step(0.5,sharp));
}
#line 213
if(ClarityBlendMode == 5)
{
#line 216
sharp = luma + 2.0*sharp-1.0;
}
#line 219
if(ClarityBlendMode == 6)
{
#line 222
sharp = saturate(luma + (sharp - 0.5));
}
}
#line 226
if( ClarityBlendIfDark > 0 || ClarityBlendIfLight < 255 || ClarityViewBlendIfMask)
{
float ClarityBlendIfD = (ClarityBlendIfDark/255.0)+0.0001;
float ClarityBlendIfL = (ClarityBlendIfLight/255.0)-0.0001;
float mix = dot(orig.rgb, 0.333333);
float mask = 1.0;
#line 233
if(ClarityBlendIfDark > 0)
{
mask = lerp(0.0,1.0,smoothstep(ClarityBlendIfD-(ClarityBlendIfD*0.2),ClarityBlendIfD+(ClarityBlendIfD*0.2),mix));
}
#line 238
if(ClarityBlendIfLight < 255)
{
mask = lerp(mask,0.0,smoothstep(ClarityBlendIfL-(ClarityBlendIfL*0.2),ClarityBlendIfL+(ClarityBlendIfL*0.2),mix));
}
#line 243
sharp = lerp(luma,sharp,mask);
#line 245
if (ClarityViewBlendIfMask)
{
sharp = mask;
luma = mask;
chroma = 1.0;
}
}
#line 253
orig.rgb = lerp(luma, sharp, ClarityStrength);
orig.rgb *= chroma;
#line 256
return saturate(orig);
}
#line 259
float Clarity1(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
float3 color = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 263
if(ClarityRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 268
color *= weight[0];
#line 270
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
}
}
#line 278
if(ClarityRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 283
color *= weight[0];
#line 285
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
}
}
#line 293
if(ClarityRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 298
color *= weight[0];
#line 300
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
}
}
#line 308
if(ClarityRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 313
color *= weight[0];
#line 315
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
}
}
#line 323
if(ClarityRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 328
color *= weight[0];
#line 330
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(ReShade::BackBuffer, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
color += tex2D(ReShade::BackBuffer, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).rgb * weight[i];
}
}
#line 338
return dot(color.rgb,float3(0.32786885,0.655737705,0.0163934436));
}
#line 341
float Clarity2(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
float color = tex2D(ClaritySampler, texcoord).r;
#line 345
if(ClarityRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 350
color *= weight[0];
#line 352
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(ClaritySampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
}
}
#line 360
if(ClarityRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 365
color *= weight[0];
#line 367
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(ClaritySampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
}
}
#line 375
if(ClarityRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 380
color *= weight[0];
#line 382
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(ClaritySampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
}
}
#line 390
if(ClarityRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 395
color *= weight[0];
#line 397
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(ClaritySampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
}
}
#line 405
if(ClarityRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 410
color *= weight[0];
#line 412
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(ClaritySampler, texcoord + float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler, texcoord - float2(0.0, offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).y) * ClarityOffset).r* weight[i];
}
}
#line 420
return color;
}
#line 423
float Clarity3(in float4 pos : SV_Position, in float2 texcoord : TEXCOORD) : COLOR
{
float color = tex2D(ClaritySampler2, texcoord).r;
#line 427
if(ClarityRadius == 0)
{
float offset[4] = { 0.0, 1.1824255238, 3.0293122308, 5.0040701377 };
float weight[4] = { 0.39894, 0.2959599993, 0.0045656525, 0.00000149278686458842 };
#line 432
color *= weight[0];
#line 434
[loop]
for(int i = 1; i < 4; ++i)
{
color += tex2D(ClaritySampler2, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler2, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
}
}
#line 442
if(ClarityRadius == 1)
{
float offset[6] = { 0.0, 1.4584295168, 3.40398480678, 5.3518057801, 7.302940716, 9.2581597095 };
float weight[6] = { 0.13298, 0.23227575, 0.1353261595, 0.0511557427, 0.01253922, 0.0019913644 };
#line 447
color *= weight[0];
#line 449
[loop]
for(int i = 1; i < 6; ++i)
{
color += tex2D(ClaritySampler2, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler2, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
}
}
#line 457
if(ClarityRadius == 2)
{
float offset[11] = { 0.0, 1.4895848401, 3.4757135714, 5.4618796741, 7.4481042327, 9.4344079746, 11.420811147, 13.4073334, 15.3939936778, 17.3808101174, 19.3677999584 };
float weight[11] = { 0.06649, 0.1284697563, 0.111918249, 0.0873132676, 0.0610011113, 0.0381655709, 0.0213835661, 0.0107290241, 0.0048206869, 0.0019396469, 0.0006988718 };
#line 462
color *= weight[0];
#line 464
[loop]
for(int i = 1; i < 11; ++i)
{
color += tex2D(ClaritySampler2, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler2, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
}
}
#line 472
if(ClarityRadius == 3)
{
float offset[15] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4401038149, 21.43402885, 23.4279736431, 25.4219399344, 27.4159294386 };
float weight[15] = { 0.0443266667, 0.0872994708, 0.0820892038, 0.0734818355, 0.0626171681, 0.0507956191, 0.0392263968, 0.0288369812, 0.0201808877, 0.0134446557, 0.0085266392, 0.0051478359, 0.0029586248, 0.0016187257, 0.0008430913 };
#line 477
color *= weight[0];
#line 479
[loop]
for(int i = 1; i < 15; ++i)
{
color += tex2D(ClaritySampler2, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler2, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
}
}
#line 487
if(ClarityRadius == 4)
{
float offset[18] = { 0.0, 1.4953705027, 3.4891992113, 5.4830312105, 7.4768683759, 9.4707125766, 11.4645656736, 13.4584295168, 15.4523059431, 17.4461967743, 19.4661974725, 21.4627427973, 23.4592916956, 25.455844494, 27.4524015179, 29.4489630909, 31.445529535, 33.4421011704 };
float weight[18] = { 0.033245, 0.0659162217, 0.0636705814, 0.0598194658, 0.0546642566, 0.0485871646, 0.0420045997, 0.0353207015, 0.0288880982, 0.0229808311, 0.0177815511, 0.013382297, 0.0097960001, 0.0069746748, 0.0048301008, 0.0032534598, 0.0021315311, 0.0013582974 };
#line 492
color *= weight[0];
#line 494
[loop]
for(int i = 1; i < 18; ++i)
{
color += tex2D(ClaritySampler2, texcoord + float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
color += tex2D(ClaritySampler2, texcoord - float2(offset[i] *  float2((1.0 / 1920), (1.0 / 1080)).x, 0.0) * ClarityOffset).r* weight[i];
}
}
#line 502
return color;
}
#line 505
technique Clarity
{
pass Clarity1
{
VertexShader = PostProcessVS;
PixelShader = Clarity1;
RenderTarget = ClarityTex;
}
#line 514
pass Clarity2
{
VertexShader = PostProcessVS;
PixelShader = Clarity2;
RenderTarget = ClarityTex2;
}
#line 521
pass Clarity3
{
VertexShader = PostProcessVS;
PixelShader = Clarity3;
RenderTarget = ClarityTex3;
}
#line 528
pass ClarityFinal
{
VertexShader = PostProcessVS;
PixelShader = ClarityFinal;
}
}

