#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\ColorMask.fx"
#line 12
namespace ColorMask
{
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 14 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\ColorMask.fx"
#line 19
uniform bool axisColorSelectON <
ui_category =  "Setup";
ui_label = "Color eyedropper instead of 'Target HUE'";
> = false;
#line 24
uniform bool drawColorSelectON <
ui_category =  "Setup";
ui_label = "Draw color eyedropper position";
ui_tooltip = "Only visible if the eyedropper is used";
> = false;
#line 30
uniform float2 axisColorSelectAxis <
ui_category =  "Setup";
ui_label = "Color eyedropper position";
ui_type = "drag";
ui_step = 0.001;
ui_min = 0.000; ui_max = 1.000;
> = float2(0.5, 0.5);
#line 38
uniform bool MaskAfterEffects <
ui_category =  "Setup";
ui_label = "Mask after effects are applied";
ui_tooltip = "Mask the colors afters the effects are applied, instead of before";
> = false;
#line 44
uniform float fUITargetHueTwo <
ui_type = "slider";
ui_category =  "Setup";
ui_label = "Target Hue";
ui_tooltip = "Set the desired color.\nEnable \"Show Debug Overlay\" for visualization.";
ui_min = 0.0; ui_max = 360.0; ui_step = 0.5;
> = 0.0;
#line 52
uniform int cUIWindowFunctionTwo <
ui_type = "combo";
ui_category =  "Setup";
ui_label = "Window Function";
ui_items = "Gauss\0Triangle\0Lineal(for highlights and shadows selection)\0";
> = 0;
#line 59
uniform float fUIOverlapTwo <
ui_type = "slider";
ui_category =  "Setup";
ui_label = "Hue Overlap";
ui_tooltip = "Grow the amount of colors being masked around the desired hue";
ui_min = 0.001; ui_max = 2.0;
ui_step = 0.001;
> = 1.7;
#line 68
uniform float fUIWindowHeightTwo <
ui_type = "slider";
ui_category =  "Setup";
ui_label = "Curve Steepness";
ui_tooltip = "The brightness of the colors accepted by the mask\nTip: Change this to 0 for neutral brigthness in Lineal mode";
ui_min = 0.0; ui_max = 10.0;
ui_step = 0.01;
> = 1.0;
#line 77
uniform float fuzzines <
ui_type = "slider";
ui_category =  "Setup";
ui_label = "Fuzzines (only for lineal function)";
ui_tooltip = "Similar to the Fuzzines option in the Color Range selection option in photoshop";
ui_min = 0; ui_max = 1.0;
ui_step = 0.01;
> = 0;
#line 86
uniform int iUITypeTwo <
ui_type = "combo";
ui_category =  "Setup";
ui_label = "Accept / Reject Colors";
ui_items = "Accept\0Reject\0";
> = 0;
#line 93
uniform float maskStrength <
ui_type = "slider";
ui_category =  "Setup";
ui_label = "Mask Strength";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
> = 1.0;
#line 101
uniform bool bUIShowDiffTwo <
ui_category =  "Debug";
ui_label = "Show Hue Difference";
> = false;
#line 106
uniform bool bUIShowDebugOverlayTwo <
ui_label = "Show Debug Overlay";
ui_category =  "Debug";
> = false;
#line 111
uniform float2 fUIOverlayPosTwo <
ui_type = "slider";
ui_category =  "Debug";
ui_label = "Overlay: Position";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
> = float2(0.0, 0.0);
#line 119
uniform int2 iUIOverlaySizeTwo <
ui_type = "slider";
ui_category =  "Debug";
ui_label = "Overlay: Size";
ui_tooltip = "x: width\nz: height";
ui_min = 50; ui_max = 3840;
ui_step = 1;
> = int2(600, 100);
#line 128
uniform float fUIOverlayOpacityTwo <
ui_type = "slider";
ui_category =  "Debug";
ui_label = "Overlay Opacity";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.01;
> = 1.0;
#line 137
texture BeforeTarget { Width = 3840; Height = 2160; };
sampler BeforeSampler { Texture = BeforeTarget; };
#line 146
float Overlay(float LayerAB)
{
float MinAB = min(LayerAB, 0.5);
float MaxAB = max(LayerAB, 0.5);
return 2.0 * (MinAB * MinAB + MaxAB + MaxAB - MaxAB * MaxAB) - 1.5;
}
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 158 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\ColorMask.fx"
#line 161
float3 RGBToHCV( in float3 RGB )
{
#line 164
float4 P         = ( RGB.g < RGB.b ) ? float4( RGB.bg, -1.0f, 2.0f/3.0f ) : float4( RGB.gb, 0.0f, -1.0f/3.0f );
float4 Q1        = ( RGB.r < P.x ) ? float4( P.xyw, RGB.r ) : float4( RGB.r, P.yzx );
float C          = Q1.x - min( Q1.w, Q1.y );
float H          = abs(( Q1.w - Q1.y ) / ( 6.0f * C + 0.000001f ) + Q1.z );
return float3( H, C, Q1.x );
}
#line 173
float3 RGBtoHSVTwo(float3 c) {
const float4 K = float4(0.0, -1.0 / 3.0, 2.0 / 3.0, -1.0);
#line 176
float4 p;
if (c.g < c.b)
p = float4(c.bg, K.wz);
else
p = float4(c.gb, K.xy);
#line 182
float4 q;
if (c.r < p.x)
q = float4(p.xyw, c.r);
else
q = float4(c.r, p.yzx);
#line 188
const float d = q.x - min(q.w, q.y);
const float e = 1.0e-10;
return float3(abs(q.z + (q.w - q.y) / (6.0 * d + e)), d / (q.x + e), q.x);
}
#line 193
float3 HSVtoRGBTwo(float3 c) {
const float4 K = float4(1.0, 2.0 / 3.0, 1.0 / 3.0, 3.0);
const float3 p = abs(frac(c.xxx + K.xyz) * 6.0 - K.www);
return c.z * lerp(K.xxx, saturate(p - K.xxx), c.y);
}
#line 199
float3 RGBToHSL( in float3 RGB )
{
RGB.xyz          = max( RGB.xyz, 0.000001f );
float3 HCV       = RGBToHCV(RGB);
float L          = HCV.z - HCV.y * 0.5f;
float S          = HCV.y / ( 1.0f - abs( L * 2.0f - 1.0f ) + 0.000001f);
return float3( HCV.x, S, L );
}
#line 208
float MapTwo(float value, float2 span_old, float2 span_new) {
float span_old_diff;
if (abs(span_old.y - span_old.x) < 1e-6)
span_old_diff = 1e-6;
else
span_old_diff = span_old.y - span_old.x;
return lerp(span_new.x, span_new.y, (clamp(value, span_old.x, span_old.y)-span_old.x)/(span_old_diff));
}
#line 221
float CalculateValueTwo(float x, float height, float offset, float overlap) {
float retVal;
#line 226
switch (cUIWindowFunctionTwo){
case 0:{
#line 229
overlap /= 5.0;
retVal = saturate( (height * exp(-((x-1.0 - offset) * (x-1.0 - offset)) / (2 * overlap * overlap))) +  (height * exp(-((x - offset) * (x - offset)) / (2 * overlap * overlap))) +  (height * exp(-((x+1.0 - offset) * (x+1.0 - offset)) / (2 * overlap * overlap))));
break;
}
case 1:{
retVal = saturate( saturate(height * ((2 / overlap) * ((overlap / 2) - abs(x-1.0 - offset)))) +  saturate(height * ((2 / overlap) * ((overlap / 2) - abs(x - offset)))) +  saturate(height * ((2 / overlap) * ((overlap / 2) - abs(x+1.0 - offset)))));
break;
}
case 2:{
retVal=fUIWindowHeightTwo/10;
break;
}
}
#line 243
if(iUITypeTwo == 1)
return 1.0 - retVal;
#line 246
return retVal;
}
#line 249
float3 DrawDebugOverlayTwo(float3 background, float3 param, float2 pos, int2 size, float opacity, int2 vpos, float2 texcoord) {
float x, y, value, luma;
float3 overlay, hsvStrip;
#line 253
const float2 overlayPos = pos * (ReShade::ScreenSize - size);
#line 255
if(all(vpos.xy >= overlayPos) && all(vpos.xy < overlayPos + size))
{
x = MapTwo(texcoord.x, float2(overlayPos.x, overlayPos.x + size.x) / 3840, float2(0.0, 1.0));
y = MapTwo(texcoord.y, float2(overlayPos.y, overlayPos.y + size.y) / 2160, float2(0.0, 1.0));
hsvStrip = HSVtoRGBTwo(float3(x, 1.0, 1.0));
luma = dot(hsvStrip, float3(0.2126, 0.7151, 0.0721));
#line 262
value = CalculateValueTwo(x, param.z, param.x, 1.0 - param.y);
overlay = lerp(luma.rrr, hsvStrip, value);
overlay = lerp(overlay, 0.0.rrr, exp(-size.y * length(float2(x, 1.0 - y) - float2(x, value))));
background = lerp(background, overlay, opacity);
}
#line 268
return background;
}
#line 271
float border(float x, float c){
if (x<=0.5-c) return 0;
if (x>=0.5+c) return 1;
return x;
}
#line 277
void BeforePS(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 280
Image = tex2D(ReShade::BackBuffer, UvCoord).rgb;
}
#line 283
void AfterPS(float4 vpos : SV_Position, float2 texcoord : TEXCOORD, out float3 fragment : SV_Target)
{
float3 actual=MaskAfterEffects ? tex2D(ReShade::BackBuffer, texcoord).rgb : tex2D(BeforeSampler, texcoord).rgb;
const float3 luma = dot(actual, float3(0.2126, 0.7151, 0.0721)).rrr;
#line 288
float3 param;
#line 290
if (axisColorSelectON) {
float3 coloraxis = tex2D(BeforeSampler, axisColorSelectAxis).rgb;
coloraxis=RGBToHCV(coloraxis);
param = float3(coloraxis.x, fUIOverlapTwo, fUIWindowHeightTwo);
}
else{
param = float3(fUITargetHueTwo / 360.0, fUIOverlapTwo, fUIWindowHeightTwo);
}
#line 299
float value;
#line 303
switch(cUIWindowFunctionTwo){
case 2:{
#line 306
if(iUITypeTwo == 1){
#line 309
value=saturate((fuzzines*20*(pow(2,RGBToHSL(actual).z)-1)+ (1-fuzzines*20)*RGBToHSL(actual).z)*(exp(fUIWindowHeightTwo/3.5)));
value=1-value;
}
else value=saturate((fuzzines*20*(pow(2,RGBToHSL(actual).z)-1)+ (1-fuzzines*20)*RGBToHSL(actual).z)*(exp(fUIWindowHeightTwo/3.5)));
#line 317
break;
}
default:{
value=CalculateValueTwo(RGBtoHSVTwo(actual).x, param.z, param.x, 1.0 - param.y);
break;
}
}
#line 328
fragment=lerp(actual,tex2D(ReShade::BackBuffer, texcoord).rgb, maskStrength*value);
#line 330
if(bUIShowDiffTwo)
fragment = value.rrr;
#line 333
if(bUIShowDebugOverlayTwo)
{
fragment = DrawDebugOverlayTwo(fragment, param, fUIOverlayPosTwo, iUIOverlaySizeTwo, fUIOverlayOpacityTwo, vpos.xy, texcoord);
}
#line 338
if(axisColorSelectON && drawColorSelectON){
fragment=lerp(fragment,float3(1.0, 0.0, 0.0),(abs(texcoord.x - axisColorSelectAxis.x)<0.0005 || abs(texcoord.y - axisColorSelectAxis.y)<0.001 ) ? 1 : 0);
}
#line 342
}
#line 348
technique BeforeColorMask < ui_tooltip = "Place this technique before the shaders you want to mask"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = BeforePS;
RenderTarget = BeforeTarget;
}
}
technique AfterColorMask < ui_tooltip = "Place this technique after the shaders you want to mask"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = AfterPS;
}
}
}
