#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\AstrayFX\DLAA_Plus.fx"
#line 40
uniform float Short_Edge_Mask <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Short Edge AA";
ui_tooltip = "Use this to adjust the Short Edge AA.\n"
"Default is 0.25";
ui_category = "DLAA";
> = 0.25;
#line 58
uniform float Long_Edge_Mask_H <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Long Edge H+";
ui_tooltip = "Use this to adjust the Super Long Edge AA.\n"
"Default is 1.0";
ui_category = "DLAA Expanded";
> = 0.0;
#line 67
uniform float Long_Edge_Mask_V <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Long Edge V+";
ui_tooltip = "Use this to adjust the Super Long Edge AA.\n"
"Default is 1.0";
ui_category = "DLAA Expanded";
> = 0.0;
#line 76
uniform float De_Artifact <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "De-Artifacting";
ui_tooltip = "Use this to adjust de-artifacting power.\n"
"Default is 0.5";
ui_category = "DLAA Debuging";
> = 0.5;
#line 85
uniform float Text_Preservation <
ui_type = "drag";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Text Preservation";
ui_tooltip = "Use this to adjust Text Preservation Power.\n"
"Default is 0.5";
ui_category = "DLAA Debuging";
> = 0.5;
#line 94
uniform int View_Mode <
ui_type = "combo";
ui_items = "DLAA\0DLAA Text Preservation\0Blue Short H/V AA Mask\0Red H & Green V Long Edge Mask\0Text Preservation Mask\0";
ui_label = "View Mode";
ui_tooltip = "This is used to select the normal view output or debug view.";
ui_category = "DLAA Debuging";
> = 0;
#line 103
uniform uint framecount < source = "framecount"; >;
#line 112
texture BackBufferTex : COLOR;
#line 114
sampler BackBuffer
{
Texture = BackBufferTex;
};
#line 119
texture DLAAtex_S {Width = 3840; Height = 2160; Format = RGBA8; };
#line 121
sampler SamplerDLAA_S
{
Texture = DLAAtex_S;
};
#line 126
texture SLPtex_H {Width = 3840; Height = 2160; Format = RGBA8; };
#line 128
sampler SamplerLoadedPixel_H
{
Texture = SLPtex_H;
};
#line 133
texture TexDLAA_H {Width = 3840; Height = 2160; Format = RGBA8; };
#line 135
sampler SamplerDLAA_H
{
Texture = TexDLAA_H;
};
#line 140
texture SLPtex_V {Width = 3840; Height = 2160; Format = RGBA8; };
#line 142
sampler SamplerLoadedPixel_V
{
Texture = SLPtex_V;
};
#line 148
float LI(in float3 value)
{
#line 153
return dot(value.rgb,float3(0.299, 0.587, 0.114));
}
#line 156
float Text_Detection(float2 texcoord)
{
float4 BC = tex2D(BackBuffer, texcoord);
#line 165
BC.a    = LI(BC.rgb);
BC.rgb /= max(BC.a, 0.001);
BC.a    = max(0.0, BC.a - Text_Preservation);
BC.rgb *= BC.a;
#line 170
return 1-dot(BC.rgb,BC.rgb);
}
#line 173
float4 SLP(float2 tc,float dx, float dy) 
{
float4 BB = tex2D(BackBuffer, tc + float2(dx, dy) *  float2((1.0 / 3840), (1.0 / 2160)).xy);
return BB;
}
#line 179
float4 DLAA_Short( float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float t, l, r, d, n, MA = 1;
#line 183
float2 UV = texcoord.xy, SW =  MA; 
float4 NFAA; 
#line 186
t = LI(SLP(texcoord, 0 ,-1).rgb);
d = LI(SLP(texcoord, 0 , 1).rgb);
l = LI(SLP(texcoord,-1 , 0).rgb);
r = LI(SLP(texcoord, 1 , 0).rgb);
n = length(float2(t - d,-(r - l)));
#line 193
float4 DLAA; 
#line 196
float4 Center = SLP(texcoord, 0 , 0);
float4 Left   = SLP(texcoord,-1.25 , 0.0);
float4 Right  = SLP(texcoord, 1.25 , 0.0);
float4 Up     = SLP(texcoord, 0.0 ,-1.25);
float4 Down   = SLP(texcoord, 0.0 , 1.25);
#line 203
float4 combH	   = 2.0 * ( Up + Down );
float4 combV	   = 2.0 * ( Left + Right );
#line 209
float4 CenterDiffH = abs( combH - 4.0 * Center ) / 4.0;
float4 CenterDiffV = abs( combV - 4.0 * Center ) / 4.0;
#line 213
float4 blurredH    = (combH + 2.0 * Center) / 6.0;
float4 blurredV    = (combV + 2.0 * Center) / 6.0;
#line 217
float LumH         = LI( CenterDiffH.rgb );
float LumV         = LI( CenterDiffV.rgb );
#line 220
float LumHB        = LI(blurredH.xyz);
float LumVB        = LI(blurredV.xyz);
#line 224
float satAmountH   = saturate( (  lerp(0,10,Short_Edge_Mask) * LumH -  0.0  ) / LumVB );
float satAmountV   = saturate( (  lerp(0,10,Short_Edge_Mask) * LumV -  0.0  ) / LumHB );
#line 229
DLAA = lerp( Center, blurredH, saturate(lerp(satAmountV ,1,-1)) );
DLAA = lerp( DLAA,   blurredV, saturate(lerp(satAmountH ,1,-1)) );
#line 233
float Mask = n * 5.0;
if (Mask > 0)
Mask = 1-Mask;
else
Mask = 1;
#line 239
Mask = saturate(lerp(Mask,1,-1));
#line 241
Mask += 1-saturate(lerp(satAmountV + satAmountH,1,-1));
#line 243
return float4(DLAA.rgb,(satAmountV + satAmountH) * 0.5);
}
#line 246
float4 LP_H(float2 tc,float dx, float dy) 
{
float4 BB = tex2D(BackBuffer, tc + float2(dx, dy) *  float2((1.0 / 3840), (1.0 / 2160)).xy);
return BB;
}
#line 252
float4 PreFilter_H(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target 
{
#line 255
float4 center = LP_H(texcoord, 0,   0);
float4 left   = LP_H(texcoord,-1.0, 0);
float4 right  = LP_H(texcoord, 1.0, 0);
float4 top    = LP_H(texcoord, 0,-1.0);
float4 bottom = LP_H(texcoord, 0, 1.0);
#line 261
float4 edges = 4.0 * abs((left + right + top + bottom) - 4.0 * center);
float  edgesLum = LI(edges.rgb);
#line 264
return float4(center.rgb, edgesLum);
}
#line 267
float4 SLP_H(float2 tc,float dx, float dy) 
{
float4 BB = tex2D(SamplerLoadedPixel_H, tc + float2(dx, dy) *  float2((1.0 / 3840), (1.0 / 2160)).xy);
return BB;
}
#line 274
float4 DLAA_H(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target 
{
#line 277
float4 DLAA, H, V, UDLR; 
float SLE_H = 2 *  lerp(1,10,Long_Edge_Mask_H);
#line 280
float4 Center = SLP_H(texcoord, 0 , 0);
#line 282
DLAA = tex2D(SamplerDLAA_S,texcoord);
float4  HNeg, HNegA, HNegB, HNegC, HNegD, HNegE,
HPos, HPosA, HPosB, HPosC, HPosD, HPosE,
VNeg, VNegA, VNegB, VNegC,
VPos, VPosA, VPosB, VPosC;
#line 290
HNeg    = SLP_H( texcoord, -1.5 , 0.0 );
HNegA   = SLP_H( texcoord, -3.5 , 0.0 );
HNegB   = SLP_H( texcoord, -5.5 , 0.0 );
HNegC   = SLP_H( texcoord, -7.0 , 0.0 );
#line 295
HPos    = SLP_H( texcoord,  1.5 , 0.0 );
HPosA   = SLP_H( texcoord,  3.5 , 0.0 );
HPosB   = SLP_H( texcoord,  5.5 , 0.0 );
HPosC   = SLP_H( texcoord,  7.0 , 0.0 );
#line 300
VNeg    = SLP_H( texcoord,  0.0,-1.5  );
VNegA   = SLP_H( texcoord,  0.0,-3.5  );
VNegB   = SLP_H( texcoord,  0.0,-5.5  );
VNegC   = SLP_H( texcoord,  0.0,-7.0  );
#line 305
VPos    = SLP_H( texcoord,  0.0, 1.5  );
VPosA   = SLP_H( texcoord,  0.0, 3.5  );
VPosB   = SLP_H( texcoord,  0.0, 5.5  );
VPosC   = SLP_H( texcoord,  0.0, 7.0  );
#line 311
float4 AvgBlurH = ( HNeg + HNegA + HNegB + HNegC + HPos + HPosA + HPosB + HPosC ) / 8;
float4 AvgBlurV = ( VNeg + VNegA + VNegB + VNegC + VPos + VPosA + VPosB + VPosC ) / 8;
float EAH = saturate( AvgBlurH.a * SLE_H - 1.0 );
float EAV = saturate( AvgBlurV.a * 2.0 - 1.0 );
#line 316
float longEdge_H = abs( EAH - EAV );
#line 318
float Mask_H = longEdge_H > 0;
#line 320
if ( Mask_H )
{
float4 up    = LP_H(texcoord, 0 ,-1);
float4 down  = LP_H(texcoord, 0 , 1);
#line 326
float LongBlurLumH = LI( AvgBlurH.rgb);
#line 328
float centerLI = LI( Center.rgb);
float upLI     = LI( up.rgb    );
float downLI   = LI( down.rgb  );
#line 332
float blurUp = saturate( 0.0 + ( LongBlurLumH - upLI      ) / (centerLI - upLI  ) );
float blurDown = saturate( 1.0 + ( LongBlurLumH - centerLI) / (centerLI - downLI) );
#line 335
UDLR = float4( 1, 1, blurUp, blurDown );
#line 337
UDLR = UDLR == float4(0.0, 0.0, 0.0, 0.0) ? float4(1.0, 1.0, 1.0, 1.0) : UDLR;
#line 339
H = lerp( up   , Center, UDLR.z );
H = lerp( down , H	 , UDLR.w );
#line 342
DLAA = lerp( DLAA , H , EAH);
}
#line 345
return float4(DLAA.rgb,EAH);
}
#line 348
float4 LP_V(float2 tc,float dx, float dy) 
{
float4 BB = tex2D(SamplerDLAA_H, tc + float2(dx, dy) *  float2((1.0 / 3840), (1.0 / 2160)).xy);
return BB;
}
#line 354
float4 PreFilter_V(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target 
{
#line 357
float4 center = LP_V(texcoord,  0,    0);
float4 left   = LP_V(texcoord, -1.0,  0);
float4 right  = LP_V(texcoord,  1.0,  0);
float4 top    = LP_V(texcoord,  0, -1.0);
float4 bottom = LP_V(texcoord,  0,  1.0);
#line 363
float4 edges = 4.0 * abs((left + right + top + bottom) - 4.0 * center);
float  edgesLum = LI(edges.rgb);
#line 366
return float4(center.rgb, edgesLum);
}
#line 369
float4 SLP_V(float2 tc,float dx, float dy) 
{
float4 BB = tex2D(SamplerLoadedPixel_V, tc + float2(dx, dy) *  float2((1.0 / 3840), (1.0 / 2160)).xy);
return BB;
}
#line 375
float4 DLAA_V(float2 texcoord)
{
#line 378
float4 DLAA, H, V, UDLR; 
float SLE_V = 2 *  lerp(1,10,Long_Edge_Mask_V);
#line 381
float4 Center = SLP_V(texcoord, 0 , 0);
#line 384
DLAA = Center;
float4  HNeg, HNegA, HNegB, HNegC, HNegD, HNegE,
HPos, HPosA, HPosB, HPosC, HPosD, HPosE,
VNeg, VNegA, VNegB, VNegC,
VPos, VPosA, VPosB, VPosC;
#line 392
HNeg    = SLP_V( texcoord, -1.5 , 0.0 );
HNegA   = SLP_V( texcoord, -3.5 , 0.0 );
HNegB   = SLP_V( texcoord, -5.5 , 0.0 );
HNegC   = SLP_V( texcoord, -7.0 , 0.0 );
#line 397
HPos    = SLP_V( texcoord,  1.5 , 0.0 );
HPosA   = SLP_V( texcoord,  3.5 , 0.0 );
HPosB   = SLP_V( texcoord,  5.5 , 0.0 );
HPosC   = SLP_V( texcoord,  7.0 , 0.0 );
#line 402
VNeg    = SLP_V( texcoord,  0.0,-1.5  );
VNegA   = SLP_V( texcoord,  0.0,-3.5  );
VNegB   = SLP_V( texcoord,  0.0,-5.5  );
VNegC   = SLP_V( texcoord,  0.0,-7.0  );
#line 407
VPos    = SLP_V( texcoord,  0.0, 1.5  );
VPosA   = SLP_V( texcoord,  0.0, 3.5  );
VPosB   = SLP_V( texcoord,  0.0, 5.5  );
VPosC   = SLP_V( texcoord,  0.0, 7.0  );
#line 413
float4 AvgBlurH = ( HNeg + HNegA + HNegB + HNegC + HPos + HPosA + HPosB + HPosC ) / 8;
float4 AvgBlurV = ( VNeg + VNegA + VNegB + VNegC + VPos + VPosA + VPosB + VPosC ) / 8;
float EAH = saturate( AvgBlurH.a * 2.0 - 1.0 );
float EAV = saturate( AvgBlurV.a * SLE_V - 1.0 );
#line 418
float longEdge_V = abs( EAV - EAH );
#line 420
float Mask_V = longEdge_V > 0;
#line 422
if ( Mask_V )
{
float4 left  = LP_V(texcoord,-1 , 0);
float4 right = LP_V(texcoord, 1 , 0);
#line 429
float LongBlurLumV = LI( AvgBlurV.rgb );
#line 431
float centerLI = LI( Center.rgb);
float leftLI   = LI( left.rgb  );
float rightLI  = LI( right.rgb );
#line 435
float blurLeft  = saturate( 0.0 + ( LongBlurLumV - leftLI  ) / (centerLI - leftLI ) );
float blurRight = saturate( 1.0 + ( LongBlurLumV - centerLI) / (centerLI - rightLI) );
#line 438
UDLR = float4( blurLeft, blurRight, 1, 1 );
#line 440
UDLR = UDLR == float4(0.0, 0.0, 0.0, 0.0) ? float4(1.0, 1.0, 1.0, 1.0) : UDLR;
#line 442
V = lerp( left , Center, UDLR.x );
V = lerp( right, V	 , UDLR.y );
#line 446
DLAA = lerp( DLAA , V , EAV);
}
#line 449
return float4(DLAA.rgb,EAV);
}
#line 453
float4 DLAA(float2 texcoord)
{
float t, l, r, d;
#line 457
float2 UV = texcoord.xy, SW =  float2((1.0 / 3840), (1.0 / 2160)), n; 
float4 D_A;
#line 460
t = LI(DLAA_V( float2( UV.x , UV.y - SW.y ) ).rgb);
d = LI(DLAA_V( float2( UV.x , UV.y + SW.y ) ).rgb);
l = LI(DLAA_V( float2( UV.x - SW.x , UV.y ) ).rgb);
r = LI(DLAA_V( float2( UV.x + SW.x , UV.y ) ).rgb);
n = float2(t - d,-(r - l));
#line 466
float nl = length(n), Rep = rcp( lerp(0,16,De_Artifact));
#line 468
if (nl < Rep)
D_A = DLAA_V(UV);
else
{
n *=  float2((1.0 / 3840), (1.0 / 2160)) / nl;
#line 474
float4   o = DLAA_V( UV ),
t0 = DLAA_V( UV + float2(n.x, -n.y)  * 0.5) * 0.9,
t1 = DLAA_V( UV - float2(n.x, -n.y)  * 0.5) * 0.9,
t2 = DLAA_V( UV + n * 0.9) * 0.75,
t3 = DLAA_V( UV - n * 0.9) * 0.75;
#line 480
D_A = (o + t0 + t1 + t2 + t3) / 4.3;
}
#line 485
float4 DLAA = D_A;
#line 487
if(View_Mode == 1)
{
DLAA =  lerp(tex2D(BackBuffer, texcoord),DLAA,Text_Detection(texcoord));
}
else if (View_Mode == 2)
{
DLAA =  lerp(DLAA,1,float4(0,0,tex2D(SamplerDLAA_S,UV).w,1));
}
else if (View_Mode == 3)
{
DLAA =  lerp(DLAA,1,float4(tex2D(SamplerDLAA_H,texcoord).w,DLAA_V(texcoord).w,0,1));
}
else if (View_Mode == 4)
{
DLAA =  lerp(float4(1,1,0,1),DLAA,Text_Detection(texcoord));
}
#line 504
return DLAA;
}
#line 507
uniform float timer < source = "timer"; >; 
#line 509
float4 Out(float4 position : SV_Position, float2 texcoord : TEXCOORD) : SV_Target
{
float PosX = 0.9525f*3840* float2((1.0 / 3840), (1.0 / 2160)).x,PosY = 0.975f*2160* float2((1.0 / 3840), (1.0 / 2160)).y;
float3 Color = DLAA(texcoord).rgb,D,E,P,T,H,Three,DD,Dot,I,N,F,O;
#line 514
[branch] if(timer <= 12500)
{
#line 518
float PosXD = -0.035+PosX, offsetD = 0.001;
float3 OneD = all( abs(float2( texcoord.x -PosXD, texcoord.y-PosY)) < float2(0.0025,0.009));
float3 TwoD = all( abs(float2( texcoord.x -PosXD-offsetD, texcoord.y-PosY)) < float2(0.0025,0.007));
D = OneD-TwoD;
#line 524
float PosXE = -0.028+PosX, offsetE = 0.0005;
float3 OneE = all( abs(float2( texcoord.x -PosXE, texcoord.y-PosY)) < float2(0.003,0.009));
float3 TwoE = all( abs(float2( texcoord.x -PosXE-offsetE, texcoord.y-PosY)) < float2(0.0025,0.007));
float3 ThreeE = all( abs(float2( texcoord.x -PosXE, texcoord.y-PosY)) < float2(0.003,0.001));
E = (OneE-TwoE)+ThreeE;
#line 531
float PosXP = -0.0215+PosX, PosYP = -0.0025+PosY, offsetP = 0.001, offsetP1 = 0.002;
float3 OneP = all( abs(float2( texcoord.x -PosXP, texcoord.y-PosYP)) < float2(0.0025,0.009*0.775));
float3 TwoP = all( abs(float2( texcoord.x -PosXP-offsetP, texcoord.y-PosYP)) < float2(0.0025,0.007*0.680));
float3 ThreeP = all( abs(float2( texcoord.x -PosXP+offsetP1, texcoord.y-PosY)) < float2(0.0005,0.009));
P = (OneP-TwoP) + ThreeP;
#line 538
float PosXT = -0.014+PosX, PosYT = -0.008+PosY;
float3 OneT = all( abs(float2( texcoord.x -PosXT, texcoord.y-PosYT)) < float2(0.003,0.001));
float3 TwoT = all( abs(float2( texcoord.x -PosXT, texcoord.y-PosY)) < float2(0.000625,0.009));
T = OneT+TwoT;
#line 544
float PosXH = -0.0072+PosX;
float3 OneH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.002,0.001));
float3 TwoH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.002,0.009));
float3 ThreeH = all( abs(float2( texcoord.x -PosXH, texcoord.y-PosY)) < float2(0.00325,0.009));
H = (OneH-TwoH)+ThreeH;
#line 551
float offsetFive = 0.001, PosX3 = -0.001+PosX;
float3 OneThree = all( abs(float2( texcoord.x -PosX3, texcoord.y-PosY)) < float2(0.002,0.009));
float3 TwoThree = all( abs(float2( texcoord.x -PosX3 - offsetFive, texcoord.y-PosY)) < float2(0.003,0.007));
float3 ThreeThree = all( abs(float2( texcoord.x -PosX3, texcoord.y-PosY)) < float2(0.002,0.001));
Three = (OneThree-TwoThree)+ThreeThree;
#line 558
float PosXDD = 0.006+PosX, offsetDD = 0.001;
float3 OneDD = all( abs(float2( texcoord.x -PosXDD, texcoord.y-PosY)) < float2(0.0025,0.009));
float3 TwoDD = all( abs(float2( texcoord.x -PosXDD-offsetDD, texcoord.y-PosY)) < float2(0.0025,0.007));
DD = OneDD-TwoDD;
#line 564
float PosXDot = 0.011+PosX, PosYDot = 0.008+PosY;
float3 OneDot = all( abs(float2( texcoord.x -PosXDot, texcoord.y-PosYDot)) < float2(0.00075,0.0015));
Dot = OneDot;
#line 570
float PosXI = 0.0155+PosX, PosYI = 0.004+PosY, PosYII = 0.008+PosY;
float3 OneI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosY)) < float2(0.003,0.001));
float3 TwoI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosYI)) < float2(0.000625,0.005));
float3 ThreeI = all( abs(float2( texcoord.x - PosXI, texcoord.y - PosYII)) < float2(0.003,0.001));
I = OneI+TwoI+ThreeI;
#line 577
float PosXN = 0.0225+PosX, PosYN = 0.005+PosY,offsetN = -0.001;
float3 OneN = all( abs(float2( texcoord.x - PosXN, texcoord.y - PosYN)) < float2(0.002,0.004));
float3 TwoN = all( abs(float2( texcoord.x - PosXN, texcoord.y - PosYN - offsetN)) < float2(0.003,0.005));
N = OneN-TwoN;
#line 583
float PosXF = 0.029+PosX, PosYF = 0.004+PosY, offsetF = 0.0005, offsetF1 = 0.001;
float3 OneF = all( abs(float2( texcoord.x -PosXF-offsetF, texcoord.y-PosYF-offsetF1)) < float2(0.002,0.004));
float3 TwoF = all( abs(float2( texcoord.x -PosXF, texcoord.y-PosYF)) < float2(0.0025,0.005));
float3 ThreeF = all( abs(float2( texcoord.x -PosXF, texcoord.y-PosYF)) < float2(0.0015,0.00075));
F = (OneF-TwoF)+ThreeF;
#line 590
float PosXO = 0.035+PosX, PosYO = 0.004+PosY;
float3 OneO = all( abs(float2( texcoord.x -PosXO, texcoord.y-PosYO)) < float2(0.003,0.005));
float3 TwoO = all( abs(float2( texcoord.x -PosXO, texcoord.y-PosYO)) < float2(0.002,0.003));
O = OneO-TwoO;
#line 595
return float4(D+E+P+T+H+Three+DD+Dot+I+N+F+O,1.) ? 1-texcoord.y*50.0+48.35f : float4(Color,1.);
}
else
return float4(Color,1.);
}
#line 604
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 612
technique Directionally_Localized_Anti_Aliasing_Plus
{
pass Short_Edge_AA
{
VertexShader = PostProcessVS;
PixelShader = DLAA_Short;
RenderTarget = DLAAtex_S;
}
pass Pre_Filter_Hoizontal
{
VertexShader = PostProcessVS;
PixelShader = PreFilter_H;
RenderTarget = SLPtex_H;
}
pass Pre_Filter_Vertical
{
VertexShader = PostProcessVS;
PixelShader = DLAA_H;
RenderTarget = TexDLAA_H;
}
pass Pre_Filter_Vertical
{
VertexShader = PostProcessVS;
PixelShader = PreFilter_V;
RenderTarget = SLPtex_V;
}
pass DLAA
{
VertexShader = PostProcessVS;
PixelShader = Out;
}
}

