#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\FreezeShot.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\FreezeShot.fx"
#line 5
uniform bool FlipH <
ui_label = "Flip Horizontal";
ui_category = "Controls";
> = false;
#line 10
uniform bool FlipV <
ui_label = "Flip Vertical";
ui_category = "Controls";
> = false;
#line 15
uniform bool Freeze <
ui_category = "Controls";
> = false;
#line 19
uniform float Shot_depth_far <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Shot depth far";
> = 0;
#line 25
uniform float Shot_depth_close <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Shot depth close";
> = 1;
#line 31
uniform float Stage_Opacity <
ui_type = "slider";
ui_label = "Opacity";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.002;
ui_tooltip = "Set the transparency of the image.";
> = 1.0;
#line 39
uniform float2 Layer_Scale <
ui_type = "slider";
ui_label = "Scale";
ui_step = 0.01;
ui_min = 0.01; ui_max = 5.0;
> = (1.5,1.5);
#line 46
uniform float2 Layer_Pos <
ui_type = "slider";
ui_label = "Position";
ui_step = 0.001;
ui_min = -1.5; ui_max = 1.5;
> = (0,0);
#line 53
uniform float Axis <
ui_type = "slider";
ui_label = "Angle";
ui_step = 0.1;
ui_min = -180.0; ui_max = 180.0;
> = 0.0;
#line 60
uniform int BlendM <
ui_type = "combo";
ui_label = "Blending Mode";
ui_tooltip = "Select the blending mode used with the gradient on the screen.";
ui_items = "Normal\0Multiply\0Screen\0Overlay\0Darken\0Lighten\0Color Dodge\0Color Burn\0Hard Light\0Soft Light\0Difference\0Exclusion\0Hue\0Saturation\0Color\0Luminosity\0Linear burn\0Linear dodge\0Vivid light\0Linearlight\0Pin light\0Hardmix\0Reflect\0Glow\0";
> = 0;
#line 67
uniform float Stage_depth <
ui_type = "slider";
ui_min = -1.0; ui_max = 1.0;
ui_label = "Layer Depth";
ui_tooltip = "If you want to use the depth from the frozen layer decrease this value";
> = 0.97;
#line 74
uniform bool BlackBackground <
ui_label = "Black Background";
ui_tooltip = "If you are using this shader for hotsampling purposes turning this on might make the process easier";
> = false;
#line 80
texture FreezeTexold		{ Width = 1920; Height = 1080; Format=RGBA8;};
texture FreezeTexnew		{ Width = 1920; Height = 1080; Format=RGBA8;};
sampler FreezeSamplernew		{ Texture = FreezeTexold; };
sampler FreezeSamplerold		{ Texture = FreezeTexnew; };
#line 86
texture DepthTexold		{ Width = 1920; Height = 1080; Format=RGBA8;};
texture DepthTexnew		{ Width = 1920; Height = 1080; Format=RGBA8;};
sampler DepthSamplernew		{ Texture = DepthTexold; };
sampler DepthSamplerold		{ Texture = DepthTexnew; };
#line 91
void GrabFrame(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float4 Image : SV_Target)
{
#line 94
float depth = 1 - ReShade::GetLinearizedDepth(UvCoord).r;
if (!Freeze){
Image= tex2D(ReShade::BackBuffer, UvCoord).rgba;
Image.a= (depth>=Shot_depth_far && depth<=Shot_depth_close) ? 1 : 0;
}
else{Image= tex2D(FreezeSamplerold, UvCoord).rgba;}
}
#line 102
void SaveFrame(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float4 Image : SV_Target)
{
#line 105
Image = tex2D(FreezeSamplernew, UvCoord).rgba;
}
#line 108
void GrabDepth(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float4 Image : SV_Target)
{
#line 111
float depth = 1 - ReShade::GetLinearizedDepth(UvCoord).r;
if (!Freeze){
Image= float3(depth,depth,depth);
Image.a= (depth>=Shot_depth_far && depth<=Shot_depth_close) ? 1 : 0;
}
else{Image= tex2D(DepthSamplerold, UvCoord).rgba;}
}
#line 119
void SaveDepth(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD, out float4 Image : SV_Target)
{
#line 122
Image = tex2D(DepthSamplernew, UvCoord).rgba;
}
#line 130
float3 Screen(float3 LayerA, float3 LayerB)
{ return 1.0 - (1.0 - LayerA) * (1.0 - LayerB); }
#line 134
float3 Multiply(float3 LayerA, float3 LayerB)
{ return LayerA * LayerB; }
#line 138
float3 Darken(float3 LayerA, float3 LayerB)
{ return min(LayerA,LayerB); }
#line 142
float3 Lighten(float3 LayerA, float3 LayerB)
{ return max(LayerA,LayerB); }
#line 146
float3 ColorDodge(float3 LayerA, float3 LayerB)
{ return (LayerB.r < 1 && LayerB.g < 1 && LayerB.b < 1) ? min(1.0,LayerA/(1.0-LayerB)) : 1.0;}
#line 150
float3 ColorBurn(float3 LayerA, float3 LayerB)
{ return (LayerB.r > 0 && LayerB.g > 0 && LayerB.b > 0) ? 1.0-min(1.0,(1.0-LayerA)/LayerB) : 0;}
#line 154
float3 HardLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(Multiply(LayerA,2*LayerB),0,1) : clamp(Multiply(LayerA,2*LayerB-1),0,1);}
#line 157
float3 Aux(float3 x)
{ return (x.r<=0.25 && x.g<=0.25 && x.b<=0.25) ? ((16.0*x-12.0)*x+4)*x : sqrt(x);}
#line 161
float3 SoftLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(LayerA-(1.0-2*LayerB)*LayerA*(1-LayerA),0,1) : clamp(LayerA+(2*LayerB-1.0)*(Aux(LayerA)-LayerA),0,1);}
#line 166
float3 Difference(float3 LayerA, float3 LayerB)
{ return LayerA-LayerB; }
#line 170
float3 Exclusion(float3 LayerA, float3 LayerB)
{ return LayerA+LayerB-2*LayerA*LayerB; }
#line 174
float3 Overlay(float3 LayerA, float3 LayerB)
{ return HardLight(LayerB,LayerA); }
#line 178
float Lum(float3 c){
return (0.3*c.r+0.59*c.g+0.11*c.b);}
#line 181
float min3 (float a, float b, float c){
return min(a,(min(b,c)));
}
#line 185
float max3 (float a, float b, float c){
return max(a,(max(b,c)));
}
#line 189
float Sat(float3 c){
return max3(c.r,c.g,c.b)-min3(c.r,c.g,c.b);}
#line 192
float3 ClipColor(float3 c){
float l=Lum(c);
float n=min3(c.r,c.g,c.b);
float x=max3(c.r,c.g,c.b);
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (n<0){
cr=l+(((cr-l)*l)/(l-n));
cg=l+(((cg-l)*l)/(l-n));
cb=l+(((cb-l)*l)/(l-n));
}
if (x>1){
cr=l+(((cr-l)*(1-l))/(x-l));
cg=l+(((cg-l)*(1-l))/(x-l));
cb=l+(((cb-l)*(1-l))/(x-l));
}
return float3(cr,cg,cb);
}
#line 212
float3 SetLum (float3 c, float l){
float d= l-Lum(c);
return float3(c.r+d,c.g+d,c.b+d);
}
#line 217
float3 SetSat(float3 c, float s){
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (cr==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cr>cb){
cg=(((cg-cb)*s)/(cr-cb));
cr=s;
}
else{
cg=0;
cr=0;
}
cb=0;
}
else{
if (cr==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cr>cg){
cb=(((cb-cg)*s)/(cr-cg));
cr=s;
}
else{
cb=0;
cr=0;
}
cg=0;
}
else{
if (cg==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cg>cb){
cr=(((cr-cb)*s)/(cg-cb));
cg=s;
}
else{
cr=0;
cg=0;
}
cb=0;
}
else{
if (cg==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cg>cr){
cb=(((cb-cr)*s)/(cg-cr));
cg=s;
}
else{
cb=0;
cg=0;
}
cr=0;
}
else{
if (cb==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cb>cg){
cr=(((cr-cg)*s)/(cb-cg));
cb=s;
}
else{
cr=0;
cb=0;
}
cg=0;
}
else{
if (cb==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cb>cr){
cg=(((cg-cr)*s)/(cb-cr));
cb=s;
}
else{
cg=0;
cb=0;
}
cr=0;
}
}
}
}
}
}
return float3(cr,cg,cb);
}
#line 300
float3 Hue(float3 b, float3 s){
return SetLum(SetSat(s,Sat(b)),Lum(b));
}
#line 304
float3 Saturation(float3 b, float3 s){
return SetLum(SetSat(b,Sat(s)),Lum(b));
}
#line 308
float3 ColorM(float3 b, float3 s){
return SetLum(s,Lum(b));
}
#line 312
float3 Luminosity(float3 b, float3 s){
return SetLum(b,Lum(s));
}
#line 319
float3 Linearburn(float3 c, float3 b) 	{ return max(c+b-1.0f, 0.0f);}
#line 321
float3 Lineardodge(float3 c, float3 b) 	{ return min(c+b, 1.0f);}
#line 323
float3 Vividlight(float3 c, float3 b) 	{ return b<0.5f ? ColorBurn(c, (2.0f*b)):ColorDodge(c, (2.0f*(b-0.5f)));}
#line 325
float3 Linearlight(float3 c, float3 b) 	{ return b<0.5f ? Linearburn(c, (2.0f*b)):Lineardodge(c, (2.0f*(b-0.5f)));}
#line 327
float3 Pinlight(float3 c, float3 b) 	{ return b<0.5f ? Darken(c, (2.0f*b)):Lighten(c, (2.0f*(b-0.5f)));}
#line 329
float3 Hardmix(float3 c, float3 b)      { return Vividlight(c,b)<0.5f ? 0.0 : 1.0;}
#line 331
float3 Reflect(float3 c, float3 b)      { return b>=0.999999f ? b:saturate(c*c/(1.0f-b));}
#line 333
float3 Glow(float3 c, float3 b)         { return Reflect(b, c);}
#line 336
float2 rotate(float2 v,float2 o, float a){
float2 v2= v-o;
v2=float2((cos(a) * v2.x-sin(a)*v2.y),sin(a)*v2.x +cos(a)*v2.y);
v2=v2+o;
return v2;
}
#line 344
void Freezef(in float4 position : SV_Position, in float2 texcoord : TEXCOORD0, out float3 color : SV_Target)
{
float2 Layer_Scalereal= float2 (Layer_Scale.x-0.44,(Layer_Scale.y-0.44)*1920/1080);
float2 Layer_Posreal= float2((FlipH) ? -Layer_Pos.x : Layer_Pos.x, (FlipV) ? Layer_Pos.y:-Layer_Pos.y);
float4 backbuffer = tex2D(ReShade::BackBuffer, texcoord).rgba;
float depth = 1 - ReShade::GetLinearizedDepth(texcoord).r;
float2 uvtemp= texcoord;
if (FlipH) {uvtemp.x = 1-uvtemp.x;}
if (FlipV) {uvtemp.y = 1-uvtemp.y;} 
uvtemp=float2(((uvtemp.x*1920-(1920-1080)/2)/1080),uvtemp.y);
uvtemp=(rotate(uvtemp,Layer_Posreal+0.5,radians(Axis))*Layer_Scalereal-((Layer_Posreal+0.5)*Layer_Scalereal-0.5));
float4 layer     = tex2D(FreezeSamplernew, uvtemp).rgba;
#line 359
float4 precolor   = lerp(backbuffer, layer, Stage_Opacity);
#line 361
color=backbuffer.rgb;
#line 363
float ImageDepthMap_depth = tex2D(DepthSamplernew,uvtemp).x;
#line 365
if( depth < saturate(ImageDepthMap_depth+Stage_depth))
{
if (uvtemp.x>0 && uvtemp.x>0 && uvtemp.y>0 && uvtemp.y>0 && uvtemp.x<1 && uvtemp.x<1 && uvtemp.y<1 && uvtemp.y<1){
switch (BlendM){
case 0:{color = lerp(backbuffer.rgb, precolor.rgb,layer.a*Stage_Opacity);break;}
case 1:{color = lerp(backbuffer.rgb, Multiply(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 2:{color = lerp(backbuffer.rgb, Screen(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 3:{color = lerp(backbuffer.rgb, Overlay(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 4:{color = lerp(backbuffer.rgb, Darken(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 5:{color = lerp(backbuffer.rgb, Lighten(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 6:{color = lerp(backbuffer.rgb, ColorDodge(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 7:{color = lerp(backbuffer.rgb, ColorBurn(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 8:{color = lerp(backbuffer.rgb, HardLight(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 9:{color = lerp(backbuffer.rgb, SoftLight(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 10:{color = lerp(backbuffer.rgb, Difference(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 11:{color = lerp(backbuffer.rgb, Exclusion(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 12:{color = lerp(backbuffer.rgb, Hue(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 13:{color = lerp(backbuffer.rgb, Saturation(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 14:{color = lerp(backbuffer.rgb, ColorM(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 15:{color = lerp(backbuffer.rgb, Luminosity(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 16:{color = lerp(backbuffer.rgb, Linearburn(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 17:{color = lerp(backbuffer.rgb, Lineardodge(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 18:{color = lerp(backbuffer.rgb, Vividlight(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 19:{color = lerp(backbuffer.rgb, Linearlight(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 20:{color = lerp(backbuffer.rgb, Pinlight(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 21:{color = lerp(backbuffer.rgb, Hardmix(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 22:{color = lerp(backbuffer.rgb, Reflect(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
case 23:{color = lerp(backbuffer.rgb, Glow(backbuffer.rgb, precolor.rgb), layer.a*Stage_Opacity);break;}
}
}
else {
if (BlackBackground) color= float3(0,0,0);
}
}
#line 401
}
#line 419
technique FreezeShot
{
pass Grab{
VertexShader = PostProcessVS;
PixelShader = GrabFrame;
RenderTarget = FreezeTexold;
}
pass Save{
VertexShader = PostProcessVS;
PixelShader = SaveFrame;
RenderTarget = FreezeTexnew;
}
pass GrabDepth{
VertexShader = PostProcessVS;
PixelShader = GrabDepth;
RenderTarget = DepthTexold;
}
pass SaveDepth{
VertexShader = PostProcessVS;
PixelShader = SaveDepth;
RenderTarget = DepthTexnew;
}
#line 442
pass
{
VertexShader = PostProcessVS;
PixelShader = Freezef;
}
}
