#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\HotsamplingHelper.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 42 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Daodan\HotsamplingHelper.fx"
#line 44
uniform float2 fUIOverlayPos <
ui_type = "drag";
ui_label = "Overlay Position";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.001;
> = float2(0.5, 0.5);
#line 51
uniform float fUIOverlayScale <
ui_type = "drag";
ui_label = "Overlay Scale";
ui_min = 0.1; ui_max = 1.0;
ui_step = 0.001;
> = 0.2;
#line 58
uniform bool bUIMaskBackground <
ui_type = "radio";
ui_label = "Mask Background";
> = true;
#line 63
float3 HotsamplingHelperPS(float4 vpos : SV_Position, float2 texcoord : TexCoord) : SV_Target {
#line 65
float2 overlayPos = fUIOverlayPos * (1.0 - fUIOverlayScale) * ReShade::ScreenSize;
#line 67
if(all(vpos.xy >= overlayPos) && all(vpos.xy < overlayPos + ReShade::ScreenSize * fUIOverlayScale))
{
texcoord = frac((texcoord - overlayPos / ReShade::ScreenSize) / fUIOverlayScale);
}
else if(bUIMaskBackground)
{
return 0.0.rrr;
}
#line 76
return tex2D(ReShade::BackBuffer, texcoord).rgb;
}
#line 79
technique HotsamplingHelper {
pass {
VertexShader = PostProcessVS;
PixelShader = HotsamplingHelperPS;
#line 84
}
}
