#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Letterbox.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 11 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Letterbox.fx"
#line 13
uniform float4 Color <      ui_type = "color"; 
ui_label = "Bars Color";
> = float4(0.027, 0.027, 0.027, 1.0);
#line 17
uniform float DesiredAspect <
ui_label = "Aspect Ratio";
ui_tooltip = "Desired Aspect Ratio float";
ui_type = "drag";
ui_min = 1.0; ui_max = 3.0;
> = 2.4;
#line 24
uniform int2 Dimensions <
ui_label = "XY Dimensions";
ui_tooltip = "Aspect Ratio below is used if set to zero";
ui_type = "drag";
ui_min = 0; ui_max = 16;
> = int2(0, 0);
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 36 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Letterbox.fx"
#line 38
float3 LetterboxPS(float4 vois : SV_Position, float2 texcoord : TexCoord) : SV_Target
{
#line 41
float RealAspect = ReShade::AspectRatio;
#line 43
float3 Display = tex2D(ReShade::BackBuffer, texcoord).rgb;
#line 45
float UserAspect = (!bool(Dimensions.x) || !bool(Dimensions.y)) ?
DesiredAspect : float(Dimensions.x) / float(Dimensions.y)
;
#line 49
if (RealAspect == UserAspect) return Display;
else if (UserAspect > RealAspect)
{
#line 53
float Bars = 0.5 - 0.5 * RealAspect / UserAspect;
return (texcoord.y > Bars && texcoord.y < 1.0 - Bars) ?
Display : lerp(Display, Color.rgb, Color.a)
;
}
else
{
#line 61
float Bars = 0.5 - 0.5 * UserAspect / RealAspect;
return (texcoord.x > Bars && texcoord.x < 1.0 - Bars) ?
Display : lerp(Display, Color.rgb, Color.a)
;
}
}
#line 73
technique Letterbox < ui_tooltip = "Letterbox / Pillarbox\n"
"Generate black-bars"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = LetterboxPS;
}
}

