#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\OtisFX\PandaFX.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 14 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\OtisFX\PandaFX.fx"
#line 16
namespace PandaFX
{
#line 20
uniform bool Enable_Diffusion <
ui_label = "Enable the lens diffusion effect";
ui_tooltip = "Enable a light diffusion that emulates the glare of a camera lens.";
> = true;
#line 25
uniform bool Enable_Bleach_Bypass <
ui_label = "Enable the 'Bleach Bypass' effect";
ui_tooltip = "Enable a cinematic contrast effect that emulates a bleach bypass on film. Used a lot in war movies and gives the image a grittier feel.";
> = true;
#line 30
uniform bool Enable_Static_Dither <
ui_label = "Apply static dither";
ui_tooltip = "Dither the diffusion. Only applies a static dither image texture.";
> = true;
#line 35
uniform bool Enable_Dither <
ui_label = "Dither the final output";
ui_tooltip = "Dither the final result of the shader.";
> = false;
#line 40
uniform float Blend_Amount <
ui_label = "Blend Amount";
ui_type = "drag";
ui_min = 0.000;
ui_max = 1.000;
ui_step = 0.01;
ui_tooltip = "Blend the effect with the original image.";
> = 0.5;
#line 49
uniform float Bleach_Bypass_Amount <
ui_label = "Bleach Bypass Amount";
ui_type = "drag";
ui_min = 0.000;
ui_max = 1.000;
ui_step = 0.01;
ui_tooltip = "Adjust the amount of the third diffusion layer.";
> = 0.5;
#line 58
uniform float Contrast_R <
ui_label = "Contrast (Red)";
ui_type = "drag";
ui_min = 0.00001;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Apply contrast to red.";
> = 0.9;
#line 67
uniform float Contrast_G <
ui_label = "Contrast (Green)";
ui_type = "drag";
ui_min = 0.00001;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Apply contrast to green.";
> = 0.8;
#line 76
uniform float Contrast_B <
ui_label = "Contrast (Blue)";
ui_type = "drag";
ui_min = 0.00001;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Apply contrast to blue.";
> = 0.8;
#line 85
uniform float Gamma_R <
ui_label = "Gamma (Red)";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.00;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to red.";
> = 1.0;
#line 94
uniform float Gamma_G <
ui_label = "Gamma (Green)";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.00;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to green.";
> = 1.0;
#line 103
uniform float Gamma_B <
ui_label = "Gamma (Blue)";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.00;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to blue.";
> = 0.99;
#line 112
uniform float Diffusion_1_Amount <
ui_category = "Diffusion layer 1";
ui_label = "Amount";
ui_type = "drag";
ui_min = 0.000;
ui_max = 1.000;
ui_step = 0.01;
ui_tooltip = "Adjust the amount of the first diffusion layer.";
> = 0.3;
#line 122
uniform float Diffusion_1_Radius <
ui_category = "Diffusion layer 1";
ui_label = "Radius";
ui_type = "drag";
ui_min = 5.0;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Set the radius of the first diffusion layer.";
> = 8.0;
#line 132
uniform float Diffusion_1_Gamma <
ui_category = "Diffusion layer 1";
ui_label = "Gamma";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.0;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to first diffusion layer.";
> = 0.7;
#line 142
uniform float Diffusion_1_Quality <
ui_category = "Diffusion layer 1";
ui_label = "Sampling quality";
ui_type = "drag";
ui_min = 1.00;
ui_max = 64.00;
ui_step = 1.0;
ui_tooltip = "Set the quality of the first diffusion layer. Number is the divider of how many times the texture size is divided in half. Lower number = higher quality, but more processing needed. (No need to adjust this.)";
> = 2.0;
#line 152
uniform float Diffusion_2_Amount <
ui_category = "Diffusion layer 2";
ui_label = "Amount";
ui_type = "drag";
ui_min = 0.000;
ui_max = 1.000;
ui_step = 0.01;
ui_tooltip = "Adjust the amount of the second diffusion layer.";
> = 0.2;
#line 162
uniform float Diffusion_2_Radius <
ui_category = "Diffusion layer 2";
ui_label = "Radius";
ui_type = "drag";
ui_min = 5.0;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Set the radius of the second diffusion layer.";
> = 5.0;
#line 172
uniform float Diffusion_2_Gamma <
ui_category = "Diffusion layer 2";
ui_label = "Gamma";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.0;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to second diffusion layer.";
> = 0.5;
#line 182
uniform float Diffusion_2_Quality <
ui_category = "Diffusion layer 2";
ui_label = "Sampling quality";
ui_type = "drag";
ui_min = 1.00;
ui_max = 64.00;
ui_step = 1.0;
ui_tooltip = "Set the quality of the second diffusion layer. Number is the divider of how many times the texture size is divided in half. Lower number = higher quality, but more processing needed. (No need to adjust this.)";
> = 16.0;
#line 192
uniform float Diffusion_3_Amount <
ui_category = "Diffusion layer 3";
ui_label = "Amount";
ui_type = "drag";
ui_min = 0.000;
ui_max = 1.000;
ui_step = 0.01;
ui_tooltip = "Adjust the amount of the third diffusion layer.";
> = 1.0;
#line 202
uniform float Diffusion_3_Radius <
ui_category = "Diffusion layer 3";
ui_label = "Radius";
ui_type = "drag";
ui_min = 5.0;
ui_max = 20.0;
ui_step = 0.01;
ui_tooltip = "Set the radius of the third diffusion layer.";
> = 7.4;
#line 212
uniform float Diffusion_3_Gamma <
ui_category = "Diffusion layer 3";
ui_label = "Gamma";
ui_type = "drag";
ui_min = 0.02;
ui_max = 5.0;
ui_step = 0.01;
ui_tooltip = "Apply Gamma to third diffusion layer.";
> = 5.0;
#line 222
uniform float Diffusion_3_Quality <
ui_category = "Diffusion layer 3";
ui_label = "Sampling quality";
ui_type = "drag";
ui_min = 1.00;
ui_max = 64.00;
ui_step = 1.0;
ui_tooltip = "Set the quality of the third diffusion layer. Number is the divider of how many times the texture size is divided in half. Lower number = higher quality, but more processing needed. (No need to adjust this.)";
> = 3.0;
#line 232
uniform int framecount < source = "framecount"; >;
#line 237
texture NoiseTex <source = "hd_noise.png"; > { Width = 1920; Height = 1080; Format = RGBA8; };
texture prePassLayer { Width = 3840; Height = 2160; Format = RGBA8; };
texture blurLayerHorizontal { Width = 3840 / 2; Height = 2160 / 2; Format = RGBA8; };
texture blurLayerVertical { Width = 3840 / 2; Height = 2160 / 2; Format = RGBA8; };
texture blurLayerHorizontalMedRes { Width = 3840 / 16; Height = 2160 / 16; Format = RGBA8; };
texture blurLayerVerticalMedRes { Width = 3840 / 16; Height = 2160 / 16; Format = RGBA8; };
texture blurLayerHorizontalLoRes { Width = 3840 / 64; Height = 2160 / 64; Format = RGBA8; };
texture blurLayerVerticalLoRes { Width = 3840 / 64; Height = 2160 / 64; Format = RGBA8; };
#line 249
sampler2D NoiseSampler { Texture = NoiseTex; };
sampler2D PFX_PrePassLayer { Texture = prePassLayer; };
#line 252
sampler2D PFX_blurHorizontalLayer { Texture = blurLayerHorizontal; };
sampler2D PFX_blurVerticalLayer { Texture = blurLayerVertical; };
sampler2D PFX_blurHorizontalLayerMedRes { Texture = blurLayerHorizontalMedRes; };
sampler2D PFX_blurVerticalLayerMedRes { Texture = blurLayerVerticalMedRes; };
sampler2D PFX_blurHorizontalLayerLoRes { Texture = blurLayerHorizontalLoRes; };
sampler2D PFX_blurVerticalLayerLoRes { Texture = blurLayerVerticalLoRes; };
#line 262
float AdjustableSigmoidCurve (float value, float amount)
{
return value < 0.5 ? pow(value, amount) * pow(2.0, amount) * 0.5
: 1.0 - pow(1.0 - value, amount) * pow(2.0, amount) * 0.5;
}
#line 268
float Randomize (float2 coord)
{
return clamp((frac(sin(dot(coord, float2(12.9898, 78.233))) * 43758.5453)), 0.0, 1.0);
}
#line 273
float SigmoidCurve (float value)
{
value = value * 2.0 - 1.0;
return -value * abs(value) * 0.5 + value + 0.5;
}
#line 279
float4 BlurH (sampler2D input, float2 uv, float radius, float sampling)
{
float4 avgColor = float4(0.0, 0.0, 0.0, 0.0);
float width = 1.0 / 3840 * (sampling + (sampling==0));
float4 tapCoord = float4(0, 0, 0, 0);
for (float x = -radius; x <= radius; x++)
{
float2 coordinate = uv + float2(x * width, 0.0);
tapCoord.xy = clamp(coordinate, 0.0, 1.0);
float weight = SigmoidCurve(1.0 - (abs(x) / (radius + (radius==0))));
avgColor.rgb += tex2Dlod(input, tapCoord).rgb * weight;
avgColor.a += weight;
}
#line 293
avgColor.rgb /= (avgColor.a + (avgColor.a==0));
avgColor.a = 1.0;
return avgColor;
}
#line 298
float4 BlurV (sampler input, float2 uv, float radius, float sampling)
{
float4 avgColor = float4(0.0, 0.0, 0.0, 0.0);
float height = 1.0 / 2160 * sampling;
float4 tapCoord = float4(0, 0, 0, 0);
for (float y = -radius; y <= radius; y++)
{
float2 coordinate = uv + float2(0.0, y * height);
tapCoord.xy = clamp(coordinate, 0.0, 1.0);
float weight = SigmoidCurve(1.0 - (abs(y) / (radius + (radius==0))));
avgColor.rgb += tex2Dlod(input, tapCoord).rgb * weight;
avgColor.a += weight;
}
#line 312
avgColor.rgb /= (avgColor.a + (avgColor.a==0));
avgColor.a = 1.0;
return avgColor;
}
#line 321
void PS_PrePass (float4 pos : SV_Position,
float2 uv : TEXCOORD,
out float4 result : SV_Target)
{
float4 A = tex2D(ReShade::BackBuffer, uv);
A.r = pow(A.r, Gamma_R);
A.g = pow(A.g, Gamma_G);
A.b = pow(A.b, Gamma_B);
A.r = AdjustableSigmoidCurve(A.r, Contrast_R);
A.g = AdjustableSigmoidCurve(A.g, Contrast_G);
A.b = AdjustableSigmoidCurve(A.b, Contrast_B);
#line 334
A.g = A.g * 0.8 + A.b * 0.2;
#line 336
float red = clamp(A.r - A.g - A.b, 0.0, 1.0);
float green = clamp(A.g - A.r - A.b, 0.0, 1.0);
float blue = clamp(A.b - A.r - A.g, 0.0, 1.0);
#line 340
A = A * (1.0 - red * 0.6);
A = A * (1.0 - green * 0.8);
A = A * (1.0 - blue * 0.3);
#line 344
result = A;
}
#line 348
void PS_HorizontalPass (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurH(PFX_PrePassLayer, uv, Diffusion_1_Radius, Diffusion_1_Quality);
}
#line 354
void PS_VerticalPass (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurV(PFX_blurHorizontalLayer, uv, Diffusion_1_Radius, Diffusion_1_Quality);
}
#line 360
void PS_HorizontalPassMedRes (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurH(PFX_blurVerticalLayer, uv, Diffusion_2_Radius, Diffusion_2_Quality);
}
#line 366
void PS_VerticalPassMedRes (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurV(PFX_blurHorizontalLayerMedRes, uv, Diffusion_2_Radius, Diffusion_2_Quality);
}
#line 372
void PS_HorizontalPassLoRes (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurH(PFX_blurVerticalLayerMedRes, uv, Diffusion_3_Radius, Diffusion_3_Quality);
}
#line 378
void PS_VerticalPassLoRes (float4 pos : SV_Position,
float2 uv : TEXCOORD, out float4 result : SV_Target)
{
result = BlurV(PFX_blurHorizontalLayerLoRes, uv, Diffusion_3_Radius, Diffusion_3_Quality);
}
#line 384
float4 PS_Composition (float4 vpos : SV_Position,
float2 uv : TEXCOORD) : SV_Target
{
#line 388
float4 blurLayer;
float4 blurLayerMedRes;
float4 blurLayerLoRes;
#line 393
float4 A = tex2D(PFX_PrePassLayer, uv);
float4 O = tex2D(ReShade::BackBuffer, uv);
float3 rndSample = tex2D(NoiseSampler, uv).rgb;
#line 397
if (Enable_Diffusion)
{
#line 400
blurLayer = tex2D(PFX_blurVerticalLayer, uv);
blurLayerMedRes = tex2D(PFX_blurVerticalLayerMedRes, uv);
blurLayerLoRes = tex2D(PFX_blurVerticalLayerLoRes, uv);
#line 405
blurLayerMedRes = lerp(blurLayerMedRes, dot(0.3333, blurLayerMedRes.rgb), 0.75);
blurLayerLoRes = lerp(blurLayerLoRes, dot(0.3333, blurLayerLoRes.rgb), 0.75);
#line 409
blurLayer *= Diffusion_1_Amount;
blurLayerMedRes *= Diffusion_2_Amount;
blurLayerLoRes *= Diffusion_3_Amount;
#line 413
blurLayer = pow(blurLayer, Diffusion_1_Gamma);
blurLayerMedRes = pow(blurLayerMedRes, Diffusion_2_Gamma);
blurLayerLoRes = pow(blurLayerLoRes, Diffusion_3_Gamma);
#line 417
if (Enable_Static_Dither)
{
float3 hd_noise = 1.0 - (rndSample * 0.01);
blurLayer.rgb = 1.0 - hd_noise * (1.0 - blurLayer.rgb);
blurLayerMedRes.rgb = 1.0 - hd_noise * (1.0 - blurLayerMedRes.rgb);
blurLayerLoRes.rgb = 1.0 - hd_noise * (1.0 - blurLayerLoRes.rgb);
}
#line 425
blurLayer = clamp(blurLayer, 0.0, 1.0);
blurLayerMedRes = clamp(blurLayerMedRes, 0.0, 1.0);
blurLayerLoRes = clamp(blurLayerLoRes, 0.0, 1.0);
#line 430
A.rgb = 1.0 - (1.0 - blurLayer.rgb) * (1.0 - A.rgb);
A.rgb = 1.0 - (1.0 - blurLayerMedRes.rgb) * (1.0 - A.rgb);
A.rgb = 1.0 - (1.0 - blurLayerLoRes.rgb) * (1.0 - A.rgb);
}
#line 436
float Ag = dot(float3(0.3333, 0.3333, 0.3333), A.rgb);
float4 C = (Ag > 0.5) ? 1 - 2 * (1 - Ag) * (1 - A) : 2 * Ag * A;
C = pow(C, 0.6);
A = lerp(A, C, Enable_Bleach_Bypass ? Bleach_Bypass_Amount : 0);
#line 444
if (Enable_Dither)
{
float uvRnd = Randomize(rndSample.rg * framecount);
float uvRnd2 = Randomize(rndSample.rg * framecount + 1);
A -= tex2D(NoiseSampler, uv * uvRnd2).r * 0.04;
A += tex2D(NoiseSampler, uv * uvRnd).r * 0.04;
}
return lerp(O, A, Blend_Amount);
}
#line 456
technique PandaFX
{
pass PreProcess
{
VertexShader = PostProcessVS;
PixelShader = PS_PrePass;
RenderTarget = prePassLayer;
}
#line 465
pass HorizontalPass
{
VertexShader = PostProcessVS;
PixelShader = PS_HorizontalPass;
RenderTarget = blurLayerHorizontal;
}
#line 472
pass VerticalPass
{
VertexShader = PostProcessVS;
PixelShader = PS_VerticalPass;
RenderTarget = blurLayerVertical;
}
#line 479
pass HorizontalPassMedRes
{
VertexShader = PostProcessVS;
PixelShader = PS_HorizontalPassMedRes;
RenderTarget = blurLayerHorizontalMedRes;
}
#line 486
pass VerticalPassMedRes
{
VertexShader = PostProcessVS;
PixelShader = PS_VerticalPassMedRes;
RenderTarget = blurLayerVerticalMedRes;
}
#line 493
pass HorizontalPassLoRes
{
VertexShader = PostProcessVS;
PixelShader = PS_HorizontalPassLoRes;
RenderTarget = blurLayerHorizontalLoRes;
}
#line 500
pass VerticalPassLoRes
{
VertexShader = PostProcessVS;
PixelShader = PS_VerticalPassLoRes;
RenderTarget = blurLayerVerticalLoRes;
}
#line 507
pass CustomPass
{
VertexShader = PostProcessVS;
PixelShader = PS_Composition ;
}
}
}
