#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SimpleGrain.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 15 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SimpleGrain.fx"
#line 17
uniform float Intensity <      ui_type = "slider"; 
ui_label = "Noise intensity";
ui_min = 0.0; ui_max = 1.0; ui_step = 0.002;
> = 0.4;
#line 22
uniform int Framerate <        ui_type = "slider"; 
ui_label = "Noise framerate";
ui_tooltip = "Zero will match in-game framerate";
#line 28
ui_min = 0; ui_max = 120;
> = 12;
#line 31
uniform int Coefficient <        ui_type = "radio"; 
ui_tooltip = "For digital video signal (HDMI, DVI, Display Port) use BT.709,\n"
"for analog (like VGA, S-Video) use BT.601";
#line 38
ui_items = "BT.709 - digital\0BT.601 - analog\0";
#line 40
> = 0;
#line 47
uniform float Timer < source = "timer"; >;
uniform int FrameCount < source = "framecount"; >;
#line 51
static const float3 Luma709 = float3(0.2126, 0.7152, 0.0722);
#line 53
static const float3 Luma601 = float3(0.299, 0.587, 0.114);
#line 56
float Overlay(float LayerA, float LayerB)
{
float MinA = min(LayerA, 0.5);
float MinB = min(LayerB, 0.5);
float MaxA = max(LayerA, 0.5);
float MaxB = max(LayerB, 0.5);
return 2 * (MinA * MinB + MaxA + MaxB - MaxA * MaxB) - 1.5;
}
#line 66
float SimpleNoise(float p)
{ return frac(sin(dot(p, float2(12.9898, 78.233))) * 43758.5453); }
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 69 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\SimpleGrain.fx"
#line 72
void SimpleGrainPS(float4 vois : SV_Position, float2 TexCoord : TEXCOORD, out float3 Image : SV_Target)
{
#line 75
float3 LumaCoefficient = bool(Coefficient) ? Luma601 : Luma709;
#line 78
Image = tex2D(ReShade::BackBuffer, TexCoord).rgb;
#line 80
const float GoldenAB = sqrt(5.0) * 0.5 + 0.5;
float Mask = pow(abs(1.0 - dot(Image.rgb, LumaCoefficient)), GoldenAB);
#line 83
float Seed = Framerate == 0 ? FrameCount : floor(Timer * 0.001 * Framerate);
#line 86
Seed %= 10000;
#line 88
const float GoldenABh = sqrt(5.0) * 0.25 + 0.25;
float Noise = saturate(SimpleNoise(Seed * TexCoord.x * TexCoord.y) * GoldenABh);
Noise = lerp(0.5, Noise, Intensity * 0.1 * Mask);
#line 92
Image.rgb = float3(
Overlay(Image.r, Noise),
Overlay(Image.g, Noise),
Overlay(Image.b, Noise)
);
}
#line 104
technique SimpleGrain < ui_label = "Simple Grain"; >
{
pass
{
VertexShader = PostProcessVS;
PixelShader = SimpleGrainPS;
}
}

