#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\SlitScan.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 5 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\SlitScan.fx"
#line 5
;
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Include/SlitScan.fxh"
#line 1
uniform float x_col <
#line 5
ui_type = "slider";
#line 7
ui_label = "Position";
ui_tooltip = "The position on the screen to start scanning. (Does not work with Animate enabled.)";
ui_max = 1.0;
ui_min = 0.0;
> = 0.250;
#line 13
uniform float scan_speed <
#line 17
ui_type = "slider";
#line 19
ui_label="Scan Speed";
ui_tooltip=
"Adjusts the rate of the scan. Lower values mean a slower scan, which can get you better images at the cost of scan speed.";
ui_max = 3.0;
ui_min = 0.0;
> = 1.0;
#line 26
uniform float min_depth <
#line 30
ui_type = "slider";
#line 32
ui_label="Minimum Depth";
ui_tooltip="Unmasks anything before a set depth.";
ui_min=0.0;
ui_max=1.0;
> = 0;
#line 38
uniform int direction <
ui_type = "combo";
ui_label = "Scan Direction";
ui_items = "Left\0Right\0Up\0Down\0";
ui_tooltip = "Changes the direction of the scan to the direction specified.";
> = 0;
#line 45
uniform int animate <
ui_type = "combo";
ui_label = "Animate";
ui_items = "No\0Yes\0";
ui_tooltip = "Animates the scanned column, moving it from one end to the other.";
> = 0;
#line 52
uniform float frame_rate <
source = "framecount";
>;
#line 56
uniform float2 anim_rate <
source = "pingpong";
min = 0.0;
max = 1.0;
step = 0.001;
smoothing = 0.0;
>;
#line 6 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\SlitScan.fx"
#line 6
;
#line 8
texture texColorBuffer: COLOR;
#line 10
texture ssTexture {
Height = 2160;
Width = 3840;
};
#line 15
sampler samplerColor {
Texture = texColorBuffer;
#line 18
Width = 3840;
Height = 2160;
Format = RGBA16;
#line 22
};
#line 24
sampler ssTarget {
Texture = ssTexture;
#line 27
AddressU = WRAP;
AddressV = WRAP;
AddressW = WRAP;
#line 31
Height = 2160;
Width = 3840;
Format = RGBA16;
};
#line 36
float get_pix_w() {
float output;
switch(direction) {
case 0:
case 1:
output = scan_speed * (1.0 / 3840);
break;
case 2:
case 3:
output = scan_speed * (1.0 / 2160);
break;
}
return output;
}
#line 52
void FullScreenVS(uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD0)
{
#line 55
if (id == 2)
texcoord.x = 2.0;
else
texcoord.x = 0.0;
#line 60
if (id == 1)
texcoord.y  = 2.0;
else
texcoord.y = 0.0;
#line 65
position = float4( texcoord * float2(2, -2) + float2(-1, 1), 0, 1);
};
#line 69
void SlitScan(float4 pos : SV_Position, float2 texcoord : TEXCOORD0, out float4 color : SV_TARGET)
{
float4 col_pixels;
float scan_col = animate ? anim_rate.x : x_col;
#line 74
switch(direction) {
case 0:
case 1:
col_pixels =  tex2D(samplerColor, float2(scan_col, texcoord.y));
break;
case 2:
case 3:
col_pixels =  tex2D(samplerColor, float2(texcoord.x, scan_col));
break;
#line 84
}
float pix_w = get_pix_w();
float slice_to_fill;
switch(direction){
case 0:
case 2:
slice_to_fill = (frame_rate * pix_w) % 1;
break;
case 1:
case 3:
slice_to_fill = abs(1-((frame_rate * pix_w) % 1));
break;
}
#line 98
float4 cols = tex2Dfetch(ssTarget, texcoord);
float4 col_to_write = tex2Dfetch(ssTarget, texcoord);
switch(direction) {
case 0:
case 1:
if(texcoord.x >= slice_to_fill - pix_w && texcoord.x <= slice_to_fill + pix_w)
col_to_write.rgba = col_pixels.rgba;
else
discard;
break;
case 2:
case 3:
if(texcoord.y >= slice_to_fill - pix_w && texcoord.y <= slice_to_fill + pix_w)
col_to_write.rgba = col_pixels.rgba;
else
discard;
break;
}
#line 117
color = col_to_write;
};
#line 120
void SlitScanPost(float4 pos : SV_Position, float2 texcoord : TEXCOORD0, out float4 color : SV_TARGET)
{
const float depth = ReShade::GetLinearizedDepth(texcoord).r;
float2 uv = texcoord;
float4 screen = tex2D(samplerColor, texcoord);
float pix_w = get_pix_w();
float scan_col;
#line 128
if(animate) scan_col = anim_rate.x;
else scan_col = x_col;
#line 131
switch(direction) {
case 0:
uv.x +=  (frame_rate * pix_w) - scan_col % 1 ;
break;
case 1:
uv.x -= (frame_rate * pix_w) - (1 - scan_col) % 1 ;
break;
case 2:
uv.y +=  (frame_rate * pix_w) - scan_col % 1 ;
break;
case 3:
uv.y -=  (frame_rate * pix_w) - (1 - scan_col) % 1 ;
break;
}
#line 146
float4 scanned = tex2D(ssTarget, uv);
#line 149
float4 mask;
switch(direction) {
case 0:
mask = step(texcoord.x, scan_col);
break;
case 1:
mask = step(scan_col, texcoord.x);
break;
case 2:
mask = step(texcoord.y, scan_col);
break;
case 3:
mask = step(scan_col, texcoord.y);
break;
}
if(depth >= min_depth)
color = lerp(screen, scanned, mask);
else
color = screen;
}
#line 170
technique SlitScan <
ui_label="Slit Scan";
> {
pass p0 {
#line 175
VertexShader = FullScreenVS;
PixelShader = SlitScan;
#line 178
RenderTarget = ssTexture;
}
#line 181
pass p1 {
#line 183
VertexShader = FullScreenVS;
PixelShader = SlitScanPost;
#line 186
}
}
