#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\StageDepthPlus.fx"
#line 48
namespace StageDepthPlus
{
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Reshade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 3840 * (1.0 / 2160);
static const float2 PixelSize = float2((1.0 / 3840), (1.0 / 2160));
static const float2 ScreenSize = float2(3840, 2160);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 50 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\CorgiFX\StageDepthPlus.fx"
#line 74
uniform bool DepthMapY <
ui_label = "Use depth map";
ui_category = "Controls";
> = false;
#line 79
uniform bool UseMask <
ui_label = "Use a mask image";
ui_category = "Controls";
> = false;
#line 84
uniform bool FlipH <
ui_label = "Flip Horizontal";
ui_category = "Controls";
> = false;
#line 89
uniform bool FlipV <
ui_label = "Flip Vertical";
ui_category = "Controls";
> = false;
#line 94
uniform float Stage_Opacity <
ui_type = "slider";
ui_label = "Opacity";
ui_min = 0.0; ui_max = 1.0;
ui_step = 0.002;
ui_tooltip = "Set the transparency of the image.";
> = 1.0;
#line 102
uniform float2 Layer_Scale <
ui_type = "slider";
ui_label = "Scale";
ui_step = 0.01;
ui_min = 0.01; ui_max = 5.0;
> = (1.001,1.001);
#line 109
uniform float2 Layer_Pos <
ui_type = "slider";
ui_label = "Position";
ui_step = 0.001;
ui_min = -1.5; ui_max = 1.5;
> = (0,0);
#line 116
uniform float Axis <
ui_type = "slider";
ui_label = "Angle";
ui_step = 0.1;
ui_min = -180.0; ui_max = 180.0;
> = 0.0;
#line 123
uniform int BlendM <
ui_type = "combo";
ui_label = "Blending Mode";
ui_tooltip = "Select the blending mode used with the gradient on the screen.";
ui_items = "Normal\0Multiply\0Screen\0Overlay\0Darken\0Lighten\0Color Dodge\0Color Burn\0Hard Light\0Soft Light\0Difference\0Exclusion\0Hue\0Saturation\0Color\0Luminosity\0Linear burn\0Linear dodge\0Vivid light\0Linearlight\0Pin light\0Hardmix\0Reflect\0Glow\0";
> = 0;
#line 130
uniform float Stage_depth <
ui_type = "slider";
ui_min = 0.0; ui_max = 1.0;
ui_label = "Depth";
> = 0.97;
#line 138
uniform float3 ProjectorPos <
ui_text = "Experimental Features\n--------------------------------------------";
ui_label = "Projector Position";
ui_type = "drag";
ui_step = 0.001;
ui_min = float3(-100,-100,-100); ui_max = float3(100,100,100);
> = float3(0.5,0.5,0);
#line 170
texture Stageplus_texture <source= "StageImage.png";> { Width =  3840; Height =  2160; Format= RGBA8;};
#line 182
texture Test_Tex <
source =  "StageDepthmap.png";
> {
Format = RGBA8;
Width  =  3840;
Height =  2160;
};
#line 190
texture Mask_tex <
source =  "StageMask.png";
> {
Format = RGBA8;
Width  =  3840;
Height =  2160;
};
#line 198
sampler Test_Sampler
{
Texture  = Test_Tex;
AddressU = BORDER;
AddressV = BORDER;
};
#line 205
sampler Stageplus_sampler { Texture = Stageplus_texture; };
#line 207
sampler Mask_sampler { Texture = Mask_tex; };
#line 225
float3 Screen(float3 LayerA, float3 LayerB)
{ return 1.0 - (1.0 - LayerA) * (1.0 - LayerB); }
#line 229
float3 Multiply(float3 LayerA, float3 LayerB)
{ return LayerA * LayerB; }
#line 233
float3 Darken(float3 LayerA, float3 LayerB)
{ return min(LayerA,LayerB); }
#line 237
float3 Lighten(float3 LayerA, float3 LayerB)
{ return max(LayerA,LayerB); }
#line 241
float3 ColorDodge(float3 LayerA, float3 LayerB)
{ return LayerB>=1.0f ? LayerB:saturate(LayerA/(1.0f-LayerB));}
#line 245
float3 ColorBurn(float3 LayerA, float3 LayerB)
{ return LayerB<=0.0f ? LayerB:saturate(1.0f-((1.0f-LayerA)/LayerB)); }
#line 249
float3 HardLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(Multiply(LayerA,2*LayerB),0,1) : clamp(Multiply(LayerA,2*LayerB-1),0,1);}
#line 252
float3 Aux(float3 x)
{ return (x.r<=0.25 && x.g<=0.25 && x.b<=0.25) ? ((16.0*x-12.0)*x+4)*x : sqrt(x);}
#line 256
float3 SoftLight(float3 LayerA, float3 LayerB)
{ return (LayerB.r <= 0.5 && LayerB.g <=0.5 && LayerB.b <= 0.5) ? clamp(LayerA-(1.0-2*LayerB)*LayerA*(1-LayerA),0,1) : clamp(LayerA+(2*LayerB-1.0)*(Aux(LayerA)-LayerA),0,1);}
#line 261
float3 Difference(float3 LayerA, float3 LayerB)
{ return LayerA-LayerB; }
#line 265
float3 Exclusion(float3 LayerA, float3 LayerB)
{ return LayerA+LayerB-2*LayerA*LayerB; }
#line 269
float3 Overlay(float3 c, float3 b)
{ return c<0.5f ? 2.0f*c*b:(1.0f-2.0f*(1.0f-c)*(1.0f-b));}
#line 273
float Lum(float3 c){
return (0.3*c.r+0.59*c.g+0.11*c.b);}
#line 276
float min3 (float a, float b, float c){
return min(a,(min(b,c)));
}
#line 280
float max3 (float a, float b, float c){
return max(a,(max(b,c)));
}
#line 284
float Sat(float3 c){
return max3(c.r,c.g,c.b)-min3(c.r,c.g,c.b);}
#line 287
float3 ClipColor(float3 c){
float l=Lum(c);
float n=min3(c.r,c.g,c.b);
float x=max3(c.r,c.g,c.b);
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (n<0){
cr=l+(((cr-l)*l)/(l-n));
cg=l+(((cg-l)*l)/(l-n));
cb=l+(((cb-l)*l)/(l-n));
}
if (x>1){
cr=l+(((cr-l)*(1-l))/(x-l));
cg=l+(((cg-l)*(1-l))/(x-l));
cb=l+(((cb-l)*(1-l))/(x-l));
}
return float3(cr,cg,cb);
}
#line 307
float3 SetLum (float3 c, float l){
float d= l-Lum(c);
return float3(c.r+d,c.g+d,c.b+d);
}
#line 312
float3 SetSat(float3 c, float s){
float cr=c.r;
float cg=c.g;
float cb=c.b;
if (cr==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cr>cb){
cg=(((cg-cb)*s)/(cr-cb));
cr=s;
}
else{
cg=0;
cr=0;
}
cb=0;
}
else{
if (cr==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cr>cg){
cb=(((cb-cg)*s)/(cr-cg));
cr=s;
}
else{
cb=0;
cr=0;
}
cg=0;
}
else{
if (cg==max3(cr,cg,cb) && cb==min3(cr,cg,cb)){
if (cg>cb){
cr=(((cr-cb)*s)/(cg-cb));
cg=s;
}
else{
cr=0;
cg=0;
}
cb=0;
}
else{
if (cg==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cg>cr){
cb=(((cb-cr)*s)/(cg-cr));
cg=s;
}
else{
cb=0;
cg=0;
}
cr=0;
}
else{
if (cb==max3(cr,cg,cb) && cg==min3(cr,cg,cb)){
if (cb>cg){
cr=(((cr-cg)*s)/(cb-cg));
cb=s;
}
else{
cr=0;
cb=0;
}
cg=0;
}
else{
if (cb==max3(cr,cg,cb) && cr==min3(cr,cg,cb)){
if (cb>cr){
cg=(((cg-cr)*s)/(cb-cr));
cb=s;
}
else{
cg=0;
cb=0;
}
cr=0;
}
}
}
}
}
}
return float3(cr,cg,cb);
}
#line 395
float3 Hue(float3 b, float3 s){
return SetLum(SetSat(s,Sat(b)),Lum(b));
}
#line 399
float3 Saturation(float3 b, float3 s){
return SetLum(SetSat(b,Sat(s)),Lum(b));
}
#line 403
float3 ColorM(float3 b, float3 s){
return SetLum(s,Lum(b));
}
#line 407
float3 Luminosity(float3 b, float3 s){
return SetLum(b,Lum(s));
}
#line 414
float3 Linearburn(float3 c, float3 b) 	{ return max(c+b-1.0f, 0.0f);}
#line 416
float3 Lineardodge(float3 c, float3 b) 	{ return min(c+b, 1.0f);}
#line 418
float3 Vividlight(float3 c, float3 b) 	{ return b<0.5f ? ColorBurn(c, (2.0f*b)):ColorDodge(c, (2.0f*(b-0.5f)));}
#line 420
float3 Linearlight(float3 c, float3 b) 	{ return b<0.5f ? Linearburn(c, (2.0f*b)):Lineardodge(c, (2.0f*(b-0.5f)));}
#line 422
float3 Pinlight(float3 c, float3 b) 	{ return b<0.5f ? Darken(c, (2.0f*b)):Lighten(c, (2.0f*(b-0.5f)));}
#line 424
float3 Hardmix(float3 c, float3 b)      { return Vividlight(c,b)<0.5f ? 0.0 : 1.0;}
#line 426
float3 Reflect(float3 c, float3 b)      { return b>=0.999999f ? b:saturate(c*c/(1.0f-b));}
#line 428
float3 Glow(float3 c, float3 b)         { return Reflect(b, c);}
#line 431
float2 rotate(float2 v,float2 o, float a){
float2 v2= v-o;
v2=float2((cos(a) * v2.x-sin(a)*v2.y),sin(a)*v2.x +cos(a)*v2.y);
v2=v2+o;
return v2;
}
#line 443
void PS_StageDepth(in float4 position : SV_Position, in float2 texcoord : TEXCOORD0, out float4 color : SV_Target)
{
#line 446
static const float3x3 ProjectionMatrix = float3x3(1, 0, ProjectorPos.x-0.5,
0, 1, ProjectorPos.y-0.5,
0, 0, ProjectorPos.z
);
#line 451
float3 uvtemp3=float3(texcoord,ReShade::GetLinearizedDepth(texcoord));
float2 uvtemp=mul(ProjectionMatrix,uvtemp3).xy;
#line 454
float4 backbuffer = tex2D(ReShade::BackBuffer, texcoord).rgba;
#line 456
color= backbuffer;
#line 458
float depth = 1 - ReShade::GetLinearizedDepth(texcoord).r;
#line 460
if (FlipH) {uvtemp.x = 1-uvtemp.x;}
if (FlipV) {uvtemp.y = 1-uvtemp.y;} 
#line 463
float2 Layer_Scalereal= float2 (Layer_Scale.x-0.44,(Layer_Scale.y-0.44)* 3840/ 2160);
#line 465
float2 Layer_Posreal= float2((FlipH) ? -Layer_Pos.x : Layer_Pos.x, (FlipV) ? Layer_Pos.y:-Layer_Pos.y);
#line 467
uvtemp= float2(((uvtemp.x*3840-(3840-2160)/2)/2160),uvtemp.y);
#line 469
uvtemp=(rotate(uvtemp,Layer_Posreal+0.5,radians(Axis))*Layer_Scalereal-((Layer_Posreal+0.5)*Layer_Scalereal-0.5));
#line 475
float4 layer  = tex2D(Stageplus_sampler, uvtemp).rgba;
if (UseMask){
float4 mask= tex2D(Mask_sampler, uvtemp).rgba;
#line 479
layer=float4(layer.rgb, min(layer.a,mask.r));
}
#line 482
float4 precolor   = lerp(backbuffer, layer, layer.a * Stage_Opacity);
#line 484
float ImageDepthMap_depth = DepthMapY ? tex2D(Test_Sampler,uvtemp).x : 0;
#line 486
if( depth < saturate(ImageDepthMap_depth+Stage_depth))
{
if (uvtemp.x>0 && uvtemp.y>0  && uvtemp.x<1 && uvtemp.y<1){
switch (BlendM){
case 0:{color = lerp(backbuffer.rgb, precolor.rgb, layer.a * Stage_Opacity);break;}
case 1:{color = lerp(backbuffer, float4 (Multiply(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 2:{color = lerp(backbuffer, float4 (Screen(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 3:{color = lerp(backbuffer, float4 (Overlay(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 4:{color = lerp(backbuffer, float4 (Darken(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 5:{color = lerp(backbuffer, float4 (Lighten(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 6:{color = lerp(backbuffer, float4 (ColorDodge(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 7:{color = lerp(backbuffer, float4 (ColorBurn(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 8:{color = lerp(backbuffer, float4 (HardLight(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 9:{color = lerp(backbuffer, float4 (SoftLight(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 10:{color = lerp(backbuffer, float4 (Difference(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 11:{color = lerp(backbuffer, float4 (Exclusion(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 12:{color = lerp(backbuffer, float4 (Hue(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 13:{color = lerp(backbuffer, float4 (Saturation(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 14:{color = lerp(backbuffer, float4 (ColorM(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 15:{color = lerp(backbuffer, float4 (Luminosity(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 16:{color = lerp(backbuffer, float4 (Lineardodge(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 17:{color = lerp(backbuffer, float4 (Linearburn(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 18:{color = lerp(backbuffer, float4 (Vividlight(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 19:{color = lerp(backbuffer, float4 (Linearlight(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 20:{color = lerp(backbuffer, float4 (Pinlight(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 21:{color = lerp(backbuffer, float4 (Hardmix(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 22:{color = lerp(backbuffer, float4 (Reflect(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
case 23:{color = lerp(backbuffer, float4 (Glow(backbuffer.rgb, precolor.rgb),backbuffer.a), layer.a * Stage_Opacity);break;}
}
}
}
#line 518
color.a = backbuffer.a;
}
#line 521
technique StageDepthPlus
{
pass
{
VertexShader = PostProcessVS;
PixelShader = PS_StageDepth;
}
}
}

