#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\VirtualResolution.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Math.fxh"
#line 3
namespace FXShaders
{
#line 68
static const float Pi = 3.14159;
#line 73
static const float DegreesToRadians = Pi / 180.0;
#line 78
static const float RadiansToDegrees = 180.0 / Pi;
#line 87
float2 GetOffsetByAngleDistance(float2 pos, float angle, float distance)
{
float2 cosSin;
sincos(angle, cosSin.y, cosSin.x);
#line 92
return mad(distance, cosSin, pos);
}
#line 102
float2 GetDirectionFromAngleMagnitude(float angle, float magnitude)
{
return GetOffsetByAngleDistance(0.0, angle, magnitude);
}
#line 114
float2 ClampMagnitude(float2 v, float2 minMax) {
if (v.x == 0.0 && v.y == 0.0)
{
return 0.0;
}
else
{
float mag = length(v);
return (mag < minMax.x) ? 0.0 : (v / mag) * min(mag, minMax.y);
}
}
#line 133
float2 RotatePoint(float2 uv, float angle, float2 pivot)
{
float2 sc;
sincos(DegreesToRadians * angle, sc.x, sc.y);
#line 138
uv -= pivot;
uv = uv.x * sc.yx + float2(-uv.y, uv.y) * sc;
uv += pivot;
#line 142
return uv;
}
#line 145
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FXShaders/Common.fxh"
#line 11
namespace FXShaders
{
#line 18
static const float FloatEpsilon = 0.001;
#line 125
float2 GetResolution()
{
return float2(2560, 1440);
}
#line 133
float2 GetPixelSize()
{
return float2((1.0 / 2560), (1.0 / 1440));
}
#line 141
float GetAspectRatio()
{
return 2560 * (1.0 / 1440);
}
#line 149
float4 GetScreenParams()
{
return float4(GetResolution(), GetPixelSize());
}
#line 165
float2 ScaleCoord(float2 uv, float2 scale, float2 pivot)
{
return (uv - pivot) * scale + pivot;
}
#line 178
float2 ScaleCoord(float2 uv, float2 scale)
{
return ScaleCoord(uv, scale, 0.5);
}
#line 188
float GetLumaGamma(float3 color)
{
return dot(color, float3(0.299, 0.587, 0.114));
}
#line 199
float GetLumaLinear(float3 color)
{
return dot(color, float3(0.2126, 0.7152, 0.0722));
}
#line 212
float3 checkered_pattern(float2 uv, float size, float color_a, float color_b)
{
static const float cSize = 32.0;
static const float3 cColorA = pow(0.15, 2.2);
static const float3 cColorB = pow(0.5, 2.2);
#line 218
uv *= GetResolution();
uv %= cSize;
#line 221
float half_size = cSize * 0.5;
float checkered = step(uv.x, half_size) == step(uv.y, half_size);
return (cColorA * checkered) + (cColorB * (1.0 - checkered));
}
#line 232
float3 checkered_pattern(float2 uv)
{
static const float Size = 32.0;
static const float ColorA = pow(0.15, 2.2);
static const float ColorB = pow(0.5, 2.2);
#line 238
return checkered_pattern(uv, Size, ColorA, ColorB);
}
#line 251
float3 ApplySaturation(float3 color, float amount)
{
float gray = GetLumaLinear(color);
return gray + (color - gray) * amount;
}
#line 262
float GetRandom(float2 uv)
{
#line 267
static const float A = 23.2345;
static const float B = 84.1234;
static const float C = 56758.9482;
#line 271
return frac(sin(dot(uv, float2(A, B))) * C);
}
#line 281
void ScreenVS(
uint id : SV_VERTEXID,
out float4 pos : SV_POSITION,
out float2 uv : TEXCOORD)
{
uv.x = (id == 2) ? 2.0 : 0.0;
uv.y = (id == 1) ? 2.0 : 0.0;
#line 289
pos = float4(uv * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 300
float2 CorrectAspectRatio(float2 uv, float a, float b)
{
if (a > b)
{
#line 306
uv = ScaleCoord(uv, float2(1.0 / a, 1.0));
}
else
{
#line 312
uv = ScaleCoord(uv, float2(1.0, 1.0 / b));
}
#line 315
return uv;
}
#line 318
} 
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\VirtualResolution.fx"
#line 23
namespace FXShaders
{
#line 26
uniform uint iScaleMode <
ui_label = "Scale Mode";
ui_type = "combo";
ui_items = "None\0Crop\0Stretch\0";
> = 0;
#line 34
uniform float fResolutionX <
ui_label = "Virtual Resolution Width";
ui_type = "drag";
ui_min = 1.0;
ui_max = 2560;
ui_step = 1.0;
> = 2560;
#line 42
uniform float fResolutionY <
ui_label = "Virtual Resolution Height";
ui_type = "drag";
ui_min = 1.0;
ui_max = 1440;
ui_step = 1.0;
> = 1440;
#line 60
static const int ScaleMode_None = 0;
static const int ScaleMode_Crop = 1;
static const int ScaleMode_Stretch = 2;
#line 64
texture BackBufferTex : COLOR;
#line 66
sampler BackBufferDownSample {
Texture = BackBufferTex;
MinFilter =  LINEAR;
MagFilter =  LINEAR;
AddressU = BORDER;
AddressV = BORDER;
};
#line 76
sampler BackBufferUpSample {
Texture = BackBufferTex;
MinFilter =  POINT;
MagFilter =  POINT;
AddressU = BORDER;
AddressV = BORDER;
};
#line 100
bool Crop(float2 uv)
{
float ar_real = GetAspectRatio();
float ar_virtual =  float2(fResolutionX, fResolutionY).x /  float2(fResolutionX, fResolutionY).y;
#line 106
bool x_or_y = ar_real > ar_virtual;
#line 108
float ar_result = x_or_y
? ar_virtual / ar_real
: ar_real / ar_virtual;
#line 112
float mask = (1.0 - (ar_result)) * 0.5;
#line 114
return x_or_y
? uv.x > mask && uv.x < 1.0 - mask
: uv.y > mask && uv.y < 1.0 - mask;
}
#line 119
float2 Stretch(float2 uv)
{
float ar_real = GetAspectRatio();
float ar_virtual =  float2(fResolutionX, fResolutionY).x /  float2(fResolutionX, fResolutionY).y;
#line 124
bool x_or_y = ar_real > ar_virtual;
#line 126
float ar_result = x_or_y
? (ar_virtual / ar_real)
: (ar_real / ar_virtual);
#line 130
float scale = 1.0 / ar_result;
#line 132
return x_or_y
? ScaleCoord(uv, float2(scale, 1.0))
: ScaleCoord(uv, float2(1.0, scale));
}
#line 137
float4 DownSamplePS(float4 pos : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
#line 140
float2 scale =  float2(fResolutionX, fResolutionY) * GetPixelSize();
float4 color = tex2D(BackBufferDownSample, ScaleCoord(uv, 1.0 / scale));
#line 143
return color;
#line 147
}
#line 149
float4 UpSamplePS(float4 pos : SV_POSITION, float2 uv : TEXCOORD) : SV_TARGET
{
float crop = iScaleMode == ScaleMode_Crop ? Crop(uv) : 1.0;
#line 153
uv = iScaleMode == ScaleMode_Stretch ? Stretch(uv) : uv;
#line 156
float2 scale =  float2(fResolutionX, fResolutionY) * GetPixelSize();
uv = ScaleCoord(uv, scale);
#line 159
float4 color = tex2D(BackBufferUpSample, uv);
#line 164
color *= crop;
#line 166
return color;
}
#line 169
technique VirtualResolution
{
pass DownSample
{
VertexShader = ScreenVS;
PixelShader = DownSamplePS;
#line 179
}
pass UpSample
{
VertexShader = ScreenVS;
PixelShader = UpSamplePS;
}
}
#line 187
} 

