#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\CheckerboardInterlace.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 2560 * (1.0 / 1440);
static const float2 PixelSize = float2((1.0 / 2560), (1.0 / 1440));
static const float2 ScreenSize = float2(2560, 1440);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 9 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\CheckerboardInterlace.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShadeUI.fxh"
#line 10 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\CheckerboardInterlace.fx"
#line 15
uniform bool HighFPS <       ui_type = "input"; 
ui_label = "Enable high FPS mode";
ui_tooltip =
"Interpolates 4-frames instead of two."
"\nUse only when game runs at 120 FPS or more";
> = false;
#line 22
uniform uint CheckerboardPattern <        ui_type = "combo"; 
ui_spacing = 1u;
ui_category = "High FPS mode settings";
ui_category_closed = true;
ui_label = "Pattern shape";
ui_tooltip =
"Works only in high FPS mode!"
"\n\nInterlace pattern shape type";
ui_items = "Z\0N'\0U\0D\0A\0C\0";
> = 0;
#line 33
uniform bool ReversePattern <       ui_type = "input"; 
ui_category = "High FPS mode settings";
ui_label = "Reverse sampling order";
ui_tooltip = "Reverse pattern winding";
> = false;
#line 39
uniform bool DisplayPattern <       ui_type = "input"; 
ui_category = "Debug settings";
ui_category_closed = true;
ui_label = "Display pattern";
ui_tooltip = "Display pattern";
> = false;
#line 46
uniform uint PatternScale <        ui_type = "slider"; 
ui_category = "Debug settings";
ui_label = "Pattern size (preview)";
ui_tooltip = "Decrease preview resolution for debugging";
ui_min = 1u; ui_max = 32u;
> = 8u;
#line 54
uniform uint FRAME_INDEX < source = "framecount"; >;
#line 60
texture interlaceTex < pooled = false; >
{
Width  = 2560;
Height = 1440;
Format = RGBA8;
};
#line 68
sampler interlaceSampler
{
Texture = interlaceTex;
MinFilter = POINT;
MagFilter = POINT;
};
#line 79
static const float4x4 PixelMask[6] =
{
#line 82
float4x4(
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 1f,
0f, 0f), 
float4(
0f, 0f,
1f, 0f), 
float4(
0f, 0f,
0f, 1f)  
),
#line 97
float4x4(
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 0f,
1f, 0f), 
float4(
0f, 1f,
0f, 0f), 
float4(
0f, 0f,
0f, 1f)  
),
#line 112
float4x4(
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 0f,
1f, 0f), 
float4(
0f, 0f,
0f, 1f), 
float4(
0f, 1f,
0f, 0f)  
),
#line 127
float4x4(
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 1f,
0f, 0f), 
float4(
0f, 0f,
0f, 1f), 
float4(
0f, 0f,
1f, 0f)  
),
#line 142
float4x4(
float4(
0f, 0f,
1f, 0f), 
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 1f,
0f, 0f), 
float4(
0f, 0f,
0f, 1f)  
),
#line 157
float4x4(
float4(
0f, 1f,
0f, 0f), 
float4(
1f, 0f,
0f, 0f), 
float4(
0f, 0f,
1f, 0f), 
float4(
0f, 0f,
0f, 1f)  
)
#line 172
};
#line 175
static const float2x4 altPixelMask = float2x4(
float4(
1f, 0f,
0f, 1f),
float4(
0f, 1f,
1f, 0f)
);
#line 188
void FullscreenTriangleVS(uint vertexID : SV_VertexID, out float4 position : SV_Position)
{
#line 191
position.z = 0f; 
position.w = 1f; 
#line 195
static const float2 positionList[3] =
{
float2(-1f, 1f),
float2( 3f, 1f),
float2(-1f,-3f)
};
#line 203
position.xy = positionList[vertexID];
}
#line 207
void CheckerboardSavePS(float4 pos : SV_Position, out float4 color : SV_Target)
{
#line 210
uint2 texelCoord = uint2(pos.xy);
#line 212
if (DisplayPattern)
{
static const float4x3 pixelColors = float4x3(
float3(1f, 0f, 0f), 
float3(0f, 1f, 0f), 
float3(0f, 0f, 1f), 
float3(1f, 1f, 1f)  
)*(235f/255f); 
#line 221
color.rgb = pixelColors[HighFPS? FRAME_INDEX%4u : FRAME_INDEX%2u];
#line 223
texelCoord /= PatternScale;
}
else color.rgb = tex2Dfetch(ReShade::BackBuffer, texelCoord).rgb;
#line 227
if (HighFPS)
color.a = PixelMask
[CheckerboardPattern] 
[ReversePattern? 3u-FRAME_INDEX%4u : FRAME_INDEX%4u] 
[(texelCoord.y%2u)*2u+(texelCoord.x%2u)] 
;
else
color.a = altPixelMask
[FRAME_INDEX%2u] 
[(texelCoord.y%2u)*2u+(texelCoord.x%2u)] 
;
}
#line 241
void CheckerboardDisplayPS(float4 pos : SV_Position, out float3 color : SV_Target)
{
#line 244
color = tex2Dfetch(interlaceSampler, uint2(pos.xy)).rgb;
}
#line 250
technique CheckerboardInterlace <
ui_label = "Checkerboard interlacing";
ui_tooltip =
"Adds checkerboard 2 or 4-frame motion-blur"
"\n\nUnder the Creative Commons CC BY-SA 3.0 license"
"\n(c) 2021 Jakub Maksymilian Fober";
>
{
pass SaveFrame
{
BlendEnable = true;
SrcBlend = SRCALPHA;     
DestBlend = INVSRCALPHA; 
#line 264
RenderTarget = interlaceTex;
#line 266
VertexShader = FullscreenTriangleVS;
PixelShader = CheckerboardSavePS;
}
pass DisplayFinal
{
VertexShader = FullscreenTriangleVS;
PixelShader = CheckerboardDisplayPS;
}
}
