#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FocalDOF.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 3 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FocalDOF.fx"
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\ReShadeUI.fxh"
#line 4 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\FocalDOF.fx"
#line 18
uniform float DofScale
<
     ui_type = "drag"; 
#line 22
ui_label = "Scale";
ui_tooltip =
"If this is empty, nag @luluco250 in the ReShade Discord channel.\n"
"\nDefault: 3.0";
ui_category = "Appearance";
ui_min = 1.0;
ui_max = 10.0;
ui_step = 0.001;
> = 3.0;
#line 32
uniform float FocusTime
<
     ui_type = "drag"; 
#line 36
ui_label = "Time";
ui_tooltip =
"If this is empty, nag @luluco250 in the ReShade Discord channel.\n"
"\nDefault: 350.0";
ui_category = "Focus";
ui_min = 0.0;
ui_max = 2000.0;
ui_step = 10.0;
> = 350.0;
#line 46
uniform float2 FocusPoint
<
     ui_type = "drag"; 
#line 50
ui_label = "Point";
ui_tooltip =
"If this is empty, nag @luluco250 in the ReShade Discord channel.\n"
"\nDefault: 0.5 0.5";
ui_category = "Focus";
ui_min = 0.0;
ui_max = 1.0;
ui_step = 0.001;
> = float2(0.5, 0.5);
#line 60
uniform float FrameTime <source = "frametime";>;
#line 78
texture FocalDOF_Focus { Format = R32F; };
sampler Focus { Texture = FocalDOF_Focus; };
#line 81
texture FocalDOF_LastFocus { Format = R32F; };
sampler LastFocus { Texture = FocalDOF_LastFocus; };
#line 88
void GetFocusVS(
uint id : SV_VERTEXID,
out float4 p : SV_POSITION,
out float2 uv : TEXCOORD0,
out float focus : TEXCOORD1)
{
PostProcessVS(id, p, uv);
#line 102
focus = 0.0;
#line 104
}
#line 106
void ReadFocusVS(
uint id : SV_VERTEXID,
out float4 p : SV_POSITION,
out float2 uv : TEXCOORD0,
out float focus : TEXCOORD1)
{
PostProcessVS(id, p, uv);
#line 117
focus = 0.0;
#line 119
}
#line 121
float4 GetFocusPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD0,
float focus : TEXCOORD1) : SV_TARGET
{
#line 127
float last = tex2Dfetch(LastFocus, 0).x;
focus = ReShade::GetLinearizedDepth(FocusPoint);
focus = lerp(last, focus, FrameTime / FocusTime);
focus = saturate(focus);
#line 133
return focus;
}
#line 136
float4 SaveFocusPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD0,
float focus : TEXCOORD1) : SV_TARGET
{
#line 142
focus = tex2Dfetch(Focus, 0).x;
#line 145
return focus;
}
#line 148
float4 MainPS(
float4 p : SV_POSITION,
float2 uv : TEXCOORD0,
float focus : TEXCOORD1) : SV_TARGET
{
float depth = ReShade::GetLinearizedDepth(uv);
float scale = abs(depth - focus) * DofScale;
#line 159
static const float2 offsets[] =
{
float2(0.0, 1.0),
float2(0.75, 0.75),
float2(1.0, 0.0),
float2(0.75, -0.75),
float2(0.0, -1.0),
float2(-0.75, -0.75),
float2(-1.0, 0.0),
float2(-0.75, 0.75)
};
#line 171
float4 color =  exp(tex2D( ReShade::BackBuffer, uv + ReShade::PixelSize * 0.0 * scale));
#line 173
[unroll]
for (int i = 0; i < 8; ++i)
color +=  exp(tex2D( ReShade::BackBuffer, uv + ReShade::PixelSize * offsets[i] * scale));
color /= 9;
#line 180
return log(color);
}
#line 187
technique FocalDOF
{
pass GetFocus
{
VertexShader = GetFocusVS;
PixelShader = GetFocusPS;
RenderTarget = FocalDOF_Focus;
}
pass SaveFocus
{
VertexShader = ReadFocusVS;
PixelShader = SaveFocusPS;
RenderTarget = FocalDOF_LastFocus;
}
pass Main
{
VertexShader = ReadFocusVS;
PixelShader = MainPS;
#line 209
}
}

