#line 1 "unknown"

#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Interlaced.fx"
#line 11
uniform int FrameCount < source = "framecount"; >;
#line 14
texture InterlacedTargetBuffer { Width = 1920; Height = 1080; };
sampler InterlacedBufferSampler { Texture = InterlacedTargetBuffer;
MagFilter = POINT;
MinFilter = POINT;
MipFilter = POINT;
};
#line 1 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\ReShade.fxh"
#line 50
namespace ReShade
{
#line 61
static const float AspectRatio = 1920 * (1.0 / 1080);
static const float2 PixelSize = float2((1.0 / 1920), (1.0 / 1080));
static const float2 ScreenSize = float2(1920, 1080);
#line 67
texture BackBufferTex : COLOR;
texture DepthBufferTex : DEPTH;
#line 70
sampler BackBuffer { Texture = BackBufferTex; };
sampler DepthBuffer { Texture = DepthBufferTex; };
#line 74
float GetLinearizedDepth(float2 texcoord)
{
#line 79
texcoord.x /=  1;
texcoord.y /=  1;
#line 84
texcoord.x -=  0 / 2.000000001;
#line 89
texcoord.y +=  0 / 2.000000001;
#line 91
float depth = tex2Dlod(DepthBuffer, float4(texcoord, 0, 0)).x *  1;
#line 98
depth = 1.0 - depth;
#line 100
const float N = 1.0;
depth /= 1000.0 - depth * (1000.0 - N);
#line 103
return depth;
}
}
#line 108
void PostProcessVS(in uint id : SV_VertexID, out float4 position : SV_Position, out float2 texcoord : TEXCOORD)
{
texcoord.x = (id == 2) ? 2.0 : 0.0;
texcoord.y = (id == 1) ? 2.0 : 0.0;
position = float4(texcoord * float2(2.0, -2.0) + float2(-1.0, 1.0), 0.0, 1.0);
}
#line 26 "E:\Games\Grand.Theft.Auto.The.Trilogy.The.Definitive.Edition.RGL.Rip-InsaneRamZes\GTA San Andreas - Definitive Edition\Gameface\Binaries\Win64\reshade-shaders\Shaders\Fubax\Interlaced.fx"
#line 29
void InterlacedTargetPass(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD,
out float4 Target : SV_Target)
{
#line 33
bool OddPixel = frac(int(ReShade::ScreenSize.y * UvCoord.y) * 0.5) != 0.0;
bool OddFrame = frac(FrameCount * 0.5) != 0.0;
bool BottomHalf = UvCoord.y > 0.5;
#line 38
float2 Coordinates;
Coordinates.x = UvCoord.x;
Coordinates.y = UvCoord.y * 2.0;
#line 42
float hPixelSizeY = ReShade::PixelSize.y * 0.5;
Coordinates.y -= BottomHalf ? 1.0 + hPixelSizeY : hPixelSizeY;
#line 45
Target = (OddFrame ? BottomHalf : UvCoord.y < 0.5) ?
float4(tex2D(ReShade::BackBuffer, Coordinates).rgb, 1.0) : 0.0;
#line 48
}
#line 51
void InterlacedPS(float4 vpos : SV_Position, float2 UvCoord : TEXCOORD,
out float3 Image : SV_Target)
{
#line 55
bool OddPixel = frac(int(ReShade::ScreenSize.y * UvCoord.y) * 0.5) != 0.0;
bool OddFrame = frac(FrameCount * 0.5) != 0.0;
#line 58
float2 Coordinates = float2(UvCoord.x, UvCoord.y * 0.5);
float qPixelSizeY = ReShade::PixelSize.y * 0.25;
Coordinates.y += OddFrame ? qPixelSizeY : qPixelSizeY + 0.5;
#line 62
Image = OddPixel ? tex2D(ReShade::BackBuffer, UvCoord).rgb
: tex2D(InterlacedBufferSampler, Coordinates).rgb;
}
#line 71
technique Interlaced
{
pass
{
VertexShader = PostProcessVS;
PixelShader = InterlacedTargetPass;
RenderTarget = InterlacedTargetBuffer;
ClearRenderTargets = false;
BlendEnable = true;
BlendOp = ADD; 
SrcBlend = SRCALPHA;
DestBlend = INVSRCALPHA;
}
pass
{
VertexShader = PostProcessVS;
PixelShader = InterlacedPS;
}
}

